#ifndef _PROTO_H_
#define _PROTO_H_
/* This file is automatically generated with "make proto". DO NOT EDIT */


/*The following definitions come from  browserd/browserd.c  */

msrpc_service_fns *get_service_fns(void);

/*The following definitions come from  browserd/srv_browserd_nt.c  */

uint32 _brs_query_info(PRS_HANDLE *con_hnd, const UNISTR2 *srv_name, uint16 switch_value,
			void *id);

/*The following definitions come from  lib/access.c  */

BOOL allow_access(char *deny_list,char *allow_list,
		  char *cname,char *caddr);
BOOL check_access(int sock, char *allow_list, char *deny_list, char *svcname);

/*The following definitions come from  lib/cmd_interp.c  */

void add_command_set(const struct command_set *cmds);
void cmd_set_no_autoconnect(void);
int command_main(int argc, char *argv[]);

/*The following definitions come from  lib/domain_namemap.c  */

BOOL map_unix_group_name(char *group_name, DOM_NAME_MAP * grp_info);
BOOL map_unix_alias_name(char *alias_name, DOM_NAME_MAP * grp_info);
BOOL map_nt_alias_name(char *ntalias_name, char *nt_domain,
		       DOM_NAME_MAP * grp_info);
BOOL map_nt_group_name(char *ntgroup_name, char *nt_domain,
		       DOM_NAME_MAP * grp_info);
BOOL lookupsmbpwnam(const char *unix_usr_name, DOM_NAME_MAP * grp);
BOOL lookupsmbpwuid(uid_t uid, DOM_NAME_MAP * gmep);
BOOL lookupsmbpwntnam(const char *fullntname, DOM_NAME_MAP * gmep);
BOOL lookupsmbpwsid(DOM_SID *sid, DOM_NAME_MAP * gmep);
BOOL lookupsmbgrpnam(const char *unix_grp_name, DOM_NAME_MAP * grp);
BOOL lookupsmbgrpgid(gid_t gid, DOM_NAME_MAP * gmep);

/*The following definitions come from  lib/doscalls.c  */

int dos_unlink(char *fname);
DIR *dos_opendir(char *dname);
char *dos_readdirname(DIR *p);
int dos_stat(char *fname,SMB_STRUCT_STAT *sbuf);
int dos_mkdir(char *dname,mode_t mode);
BOOL dos_file_exist(char *fname,SMB_STRUCT_STAT *sbuf);

/*The following definitions come from  lib/hash.c  */

BOOL hash_table_init(hash_table *table, int num_buckets, compare_function compare_func);
hash_element *hash_lookup(hash_table *table, char *key);
hash_element *hash_insert(hash_table *table, char *value, char *key);
void hash_remove(hash_table *table, hash_element *hash_elem);
void hash_clear(hash_table *table);

/*The following definitions come from  lib/passcheck.c  */

BOOL smb_password_ok(uint16 acct_ctrl,
				uchar smb_passwd[16],
				uchar smb_nt_passwd[16],
				const uchar challenge[8],
				const char *user, const char *domain,
				const uchar *lm_pass, size_t lm_pwd_len,
				const uchar *nt_pass, size_t nt_pwd_len,
				uchar user_sess_key[16]);

/*The following definitions come from  lib/set_uid.c  */

uint16 get_sec_ctx(void);
void init_uid(void);
BOOL unbecome_to_initial_uid(void);
BOOL become_unix_sec_ctx(uint16 vuid, connection_struct * conn,
			 uid_t new_uid, gid_t new_gid,
			 int n_groups, gid_t * groups);
BOOL become_guest(void);
void become_root(void);
void unbecome_root(void);
BOOL become_system(void);
BOOL unbecome_system(void);

/*The following definitions come from  lib/set_vuid.c  */

void init_vuid(void);
BOOL become_vuser(uint16 vuid);
BOOL unbecome_vuser(void);

/*The following definitions come from  lib/sids.c  */

struct sid_map* add_sidmap_to_array(uint32 *len, struct sid_map ***array,
				const struct sid_map *name);
void generate_wellknown_sids(void);
BOOL pwdb_initialise(BOOL is_server);
const DOM_SID *map_wk_name_to_sid(const char *name, DOM_SID *sid, uint32 *type);
const char *map_wk_sid_to_name(const DOM_SID *sid, char *nt_domain, uint32 *type);
BOOL map_domain_sid_to_name(DOM_SID *sid, char *nt_domain);
BOOL map_domain_sid_to_any_dc(DOM_SID *sid, char *dc_name);
BOOL split_domain_name(const char *fullname, char *domain, char *name);
BOOL enumtrustdoms(char ***doms, uint32 *num_entries);

/*The following definitions come from  lib/stub_uid.c  */

uint16 get_sec_ctx(void);

/*The following definitions come from  lib/surs.c  */

BOOL surs_sam_sid_to_unixid(const SURS_SID_ID *sid, SURS_POSIX_ID *id, BOOL create);
BOOL surs_unixid_to_sam_sid(const SURS_POSIX_ID *id, SURS_SID_ID *sid, BOOL create);

/*The following definitions come from  lib/sursalgdomonly.c  */

BOOL surs_algdomonly_sam_sid_to_unixid(const DOM_SID *sid, SURS_POSIX_ID *id,
				BOOL create);
BOOL surs_algdomonly_unixid_to_sam_sid(const SURS_POSIX_ID *id, DOM_SID *sid,
				BOOL create);

/*The following definitions come from  lib/sursalgnt5ldap.c  */

BOOL surs_nt5ldap_sam_sid_to_unixid(LDAPDB *hds, DOM_SID * sid, uint32 type,
				    uint32 * id, BOOL create);
BOOL surs_nt5ldap_unixid_to_sam_sid(LDAPDB *hds, uint32 id, uint32 type,
				    DOM_SID * sid, BOOL create);

/*The following definitions come from  lib/surstdb.c  */

BOOL surs_tdb_sam_sid_to_unixid(DOM_SID * sid, uint32 type, uint32 * id,
				BOOL create);
BOOL surs_tdb_unixid_to_sam_sid(uint32 id, uint32 type, DOM_SID * sid,
				BOOL create);

/*The following definitions come from  lib/util_hnd.c  */

struct policy_cache *get_global_hnd_cache(void);
struct policy_cache *init_policy_cache(int num_pol_hnds);
void free_policy_cache(struct policy_cache *cache);
BOOL policy_hnd_set_name(struct policy_cache *cache,
			 POLICY_HND *hnd, const char *name);
const char *policy_hnd_get_name(struct policy_cache *cache,
				const POLICY_HND *hnd);
BOOL dup_policy_hnd(struct policy_cache *cache,
		    POLICY_HND *hnd, const POLICY_HND *from);
BOOL register_policy_hnd(struct policy_cache *cache,
			 uint16 vuid,
			 POLICY_HND *hnd, uint32 access_mask);
BOOL open_policy_hnd(struct policy_cache *cache,
		     uint16 vuid,
		     POLICY_HND *hnd, uint32 access_mask);
BOOL open_policy_hnd_link(struct policy_cache *cache,
			  const POLICY_HND *parent_hnd,
			  POLICY_HND *hnd, uint32 access_mask);
int find_policy_by_hnd(struct policy_cache *cache, const POLICY_HND *hnd);
BOOL set_policy_state(struct policy_cache *cache, POLICY_HND *hnd,
		      void (*fn) (void *), void *dev);
void *get_policy_state_info(struct policy_cache *cache, const POLICY_HND *hnd);
BOOL policy_hnd_set_state_type(struct policy_cache *cache,
			       POLICY_HND *hnd, int type);
int policy_hnd_get_state_type(struct policy_cache *cache,
			      const POLICY_HND *hnd);
BOOL policy_hnd_check_state_type(struct policy_cache *cache,
				 const POLICY_HND *hnd, int type);
BOOL close_policy_hnd(struct policy_cache *cache, POLICY_HND *hnd);
BOOL policy_link_key(struct policy_cache *cache, const POLICY_HND *hnd,
		     POLICY_HND *to);
uint16 get_policy_vuid(struct policy_cache *cache,
				      const POLICY_HND *hnd);
BOOL pol_get_usr_sesskey(struct policy_cache *cache, const POLICY_HND *hnd,
			 uchar usr_sess_key[16]);

/*The following definitions come from  lib/util_login.c  */

const struct passwd *map_nt_and_unix_username(const char *domain,
					      const char *ntuser,
					      char *unix_user, char *nt_user);

/*The following definitions come from  lib/util_nttoken.c  */

const NT_USER_TOKEN *get_current_nt_token(void);

/*The following definitions come from  lib/util_pwdb.c  */

uint32 lookup_wk_group_name(const char *group_name, const char *domain,
				DOM_SID *sid, uint32 *type);
uint32 lookup_wk_user_name(const char *user_name, const char *domain,
				DOM_SID *sid, uint32 *type);
uint32 lookup_builtin_alias_name(const char *alias_name, const char *domain,
				DOM_SID *sid, uint32 *type);
char *lookup_wk_alias_rid(uint32 rid);
char *lookup_wk_user_rid(uint32 rid);
char *lookup_wk_group_rid(uint32 rid);

/*The following definitions come from  lib/util_seaccess.c  */

void se_map_generic(uint32 *access_mask, struct generic_mapping *mapping);
BOOL se_access_check(SEC_DESC *sd, NT_USER_TOKEN *token,
		     uint32 acc_desired, uint32 *acc_granted,
		     NTSTATUS *status);

/*The following definitions come from  lib/util_status.c  */

BOOL get_connection_status(struct connect_record **crec,
				uint32 *connection_count);
BOOL get_session_count(struct connect_record **srec,uint32 *session_count);
BOOL get_locks_count(int pid, uint32 *locks_count);

/*The following definitions come from  lib/util_unixsd.c  */

size_t convertperms_unix_to_sd(const SMB_STRUCT_STAT * sbuf,
			       BOOL is_directory, mode_t mode,
			       SEC_DESC ** ppdesc);
BOOL convertperms_sd_to_unix(SMB_STRUCT_STAT * psbuf, uid_t * puser,
			     gid_t * pgrp, mode_t * pmode,
			     uint32 security_info_sent, SEC_DESC * psd,
			     BOOL is_directory);

/*The following definitions come from  lib/vuser.c  */

uint32 vuid_get_flags(uint16 vuid);
user_struct *get_valid_user_struct(uint16 vuid);
user_struct *get_public_user_struct(uint16 vuid);
void invalidate_vuid(uint16 vuid);
BOOL validated_username(uint16 vuid, char *name, size_t len);
uint16 make_vuid(user_struct *vuser);
uint16 register_vuid(pid_t pid, uid_t uid, gid_t gid,
		     const char *unix_name,
		     const char *requested_name,
		     BOOL guest, uint32 flags, const NET_USER_INFO_3 * info3);
BOOL check_vuser_ok(struct uid_cache *cache, user_struct * vuser, int snum);
BOOL vuid_get_usr_sesskey(uint16 vuid, uchar usr_sess_key[16]);
uint16 vuid_create_system(void);

/*The following definitions come from  lib/vuser_db.c  */

BOOL tdb_delete_vuid( uint16 vuid);
BOOL tdb_lookup_vuid( uint16 vuid, user_struct **usr);
BOOL tdb_store_vuid(uint16 vuid, user_struct *usr, BOOL overwrite);

/*The following definitions come from  libsmb/passchange.c  */

BOOL remote_password_change(const char *remote_machine, const char *user_name,
			    const char *old_passwd, const char *new_passwd,
			    char *err_str, size_t err_str_len);

/*The following definitions come from  locking/brlock.c  */

void brl_init(int read_only);
BOOL brl_lock(SMB_DEV_T dev, SMB_INO_T ino, int fnum,
	      uint16 smbpid, pid_t pid, uint16 tid,
	      br_off start, br_off size,
	      enum brl_type lock_type);
BOOL brl_unlock(SMB_DEV_T dev, SMB_INO_T ino, int fnum,
		uint16 smbpid, pid_t pid, uint16 tid,
		br_off start, br_off size);
BOOL brl_locktest(SMB_DEV_T dev, SMB_INO_T ino, int fnum,
		  uint16 smbpid, pid_t pid, uint16 tid,
		  br_off start, br_off size,
		  enum brl_type lock_type);
void brl_close(SMB_DEV_T dev, SMB_INO_T ino, pid_t pid, int tid, int fnum);
int brl_forall(BRLOCK_FN(fn));

/*The following definitions come from  locking/locking.c  */

BOOL is_locked(files_struct *fsp,connection_struct *conn,
	       SMB_BIG_UINT count,SMB_BIG_UINT offset,
	       enum brl_type lock_type);
BOOL do_lock(files_struct *fsp,connection_struct *conn,
             SMB_BIG_UINT count,SMB_BIG_UINT offset,enum brl_type lock_type,
             int *eclass,uint32 *ecode);
BOOL do_unlock(files_struct *fsp,connection_struct *conn,
               SMB_BIG_UINT count,SMB_BIG_UINT offset,
	       int *eclass,uint32 *ecode);
void locking_close_file(files_struct *fsp);
BOOL locking_init(int read_only);
BOOL locking_end(void);
BOOL lock_share_entry(connection_struct *conn,
		      SMB_DEV_T dev, SMB_INO_T inode);
void unlock_share_entry(connection_struct *conn,
			SMB_DEV_T dev, SMB_INO_T inode);
BOOL lock_share_entry_fsp(files_struct *fsp);
void unlock_share_entry_fsp(files_struct *fsp);
int get_share_modes(connection_struct *conn,
		    SMB_DEV_T dev, SMB_INO_T inode,
		    share_mode_entry **shares);
void del_share_mode(files_struct *fsp);
BOOL set_share_mode(files_struct *fsp, uint16 port, uint16 op_type);
BOOL remove_share_oplock(files_struct *fsp);
BOOL downgrade_share_oplock(files_struct *fsp);
BOOL modify_share_mode(files_struct *fsp, int new_mode, uint16 new_oplock);
int share_mode_forall(SHAREMODE_FN(fn));

/*The following definitions come from  locking/posix.c  */

int fd_close_posix(struct connection_struct *conn, files_struct *fsp);
BOOL is_posix_locked(files_struct *fsp, SMB_BIG_UINT u_offset, SMB_BIG_UINT u_count, enum brl_type lock_type);
BOOL set_posix_lock(files_struct *fsp, SMB_BIG_UINT u_offset, SMB_BIG_UINT u_count, enum brl_type lock_type);
BOOL release_posix_lock(files_struct *fsp, SMB_BIG_UINT u_offset, SMB_BIG_UINT u_count);
void posix_locking_close_file(files_struct *fsp);
BOOL posix_locking_init(int read_only);
BOOL posix_locking_end(void);

/*The following definitions come from  lsarpcd/lsarpcd.c  */

msrpc_service_fns *get_service_fns(void);

/*The following definitions come from  lsarpcd/secret_db.c  */

BOOL tdb_delete_secret(TDB_CONTEXT * tdb, const UNISTR2 * uk);
BOOL tdb_lookup_secret(TDB_CONTEXT * tdb, const UNISTR2 * uk,
		       LSA_SECRET ** usr);
BOOL tdb_store_secret(TDB_CONTEXT * tdb, const UNISTR2 * uk, LSA_SECRET * usr);
TDB_CONTEXT *open_secret_db(int perms);
BOOL secret_init_db(void);

/*The following definitions come from  lsarpcd/srv_lsa.c  */

BOOL api_ntlsa_rpc(rpcsrv_struct * p);

/*The following definitions come from  lsarpcd/srv_lsa_samdb.c  */

uint32 _lsa_open_policy2(const UNISTR2 * server_name, POLICY_HND * hnd,
			 const LSA_OBJ_ATTR * attr, uint32 des_access);
uint32 _lsa_open_policy(const UNISTR2 * server_name, POLICY_HND * hnd,
			const LSA_OBJ_ATTR * attr, uint32 des_access);
uint32 _lsa_enum_trust_dom(POLICY_HND * hnd, uint32 *enum_ctx,
			   uint32 *ret_num_doms, UNISTR2 **uni_names,
			   DOM_SID ***sids);
uint32 _lsa_lookup_names(const POLICY_HND * pol,
			 uint32 num_entries, const UNISTR2 * name,
			 DOM_R_REF * ref, DOM_RID2 ** ret_rid2,
			 uint32 * mapped_count);
uint32 _lsa_lookup_sids(const POLICY_HND * hnd,
			uint32 num_entries, DOM_SID2 * sid,
			const LOOKUP_LEVEL * level,
			DOM_R_REF * ref,
			LSA_TRANS_NAME_ENUM * trn, uint32 * mapped_count);
uint32 _lsa_query_info_pol(POLICY_HND * hnd, uint16 info_class,
			   LSA_INFO_UNION *info);
uint32 _lsa_close(POLICY_HND * hnd);
uint32 _lsa_set_secret(const POLICY_HND * hnd_secret,
		       const STRING2 * val, uint32 unknown);
uint32 _lsa_query_secret(const POLICY_HND * hnd_secret,
			 STRING2 * curval, NTTIME * curtime,
			 STRING2 * oldval, NTTIME * oldtime);
uint32 _lsa_create_secret(const POLICY_HND * hnd,
			  const UNISTR2 * secret_name, uint32 des_access,
			  POLICY_HND * hnd_secret);
uint32 _lsa_open_secret(const POLICY_HND * hnd,
			const UNISTR2 * secret_name, uint32 des_access,
			POLICY_HND * hnd_secret);
uint32 _lsa_enum_privs(POLICY_HND *hnd, uint32 unk0, uint32 unk1,
		       uint32 *count, LSA_PRIV_ENTRY **entries);
uint32 _lsa_unk_2d(const UNISTR2 uni_servername, LSA_R_UNK_2D* r_u);
uint32 _lsa_priv_get_dispname(const POLICY_HND *hnd,
			      const UNISTR2 *name,
			      uint16 lang_id, uint16 lang_id_sys,
			      UNISTR2 **desc, uint16 *ret_lang_id);
uint32 _lsa_open_trusted_dom(const POLICY_HND *hnd, const DOM_SID *sid,
			     uint32 des_access, POLICY_HND *hnd_dom);
uint32 _lsa_delete_object(POLICY_HND *hnd);

/*The following definitions come from  msdfs/msdfs.c  */

BOOL is_msdfs_link(connection_struct* conn, char* path);
BOOL dfs_redirect(char* pathname, connection_struct* conn);
BOOL dfs_findfirst_redirect(char* pathname, connection_struct* conn);
int setup_dfs_referral(char* pathname, int max_referral_level,
			char** ppdata);
int dfs_path_error(char* inbuf, char* outbuf);
int setup_dfs_referral(char* pathname, int max_referral_level,
		       char** ppdata);
BOOL is_msdfs_link(connection_struct* conn, char* path);

/*The following definitions come from  msrpc/msrpcd.c  */

void exit_server(char *reason);

/*The following definitions come from  msrpc/msrpcd_process.c  */

void close_srv_auth_array(rpcsrv_struct * l);
void add_srv_auth_fn(rpcsrv_struct * l, srv_auth_fns * fn);
BOOL msrpcd_init(int c, rpcsrv_struct ** l);
void msrpcd_process(msrpc_service_fns * fn, rpcsrv_struct * l,
		    const char *name);

/*The following definitions come from  netlogond/creds_db.c  */

BOOL cred_get(const char *domain, const char* wks, struct dcinfo *dc);
BOOL cred_store(const char *domain, const char* wks, struct dcinfo *dc);
BOOL cred_init_db(void);

/*The following definitions come from  netlogond/netlogond.c  */

msrpc_service_fns *get_service_fns(void);

/*The following definitions come from  netlogond/srv_netlogon_nt.c  */

uint32 _net_logon_ctrl2(PRS_HANDLE *con_hnd, const UNISTR2 *uni_server_name,
			uint32 function_code,
			uint32 query_level,
			uint32 switch_value,
			uint32 *reply_switch_value,
			NETLOGON_INFO * logon_info);
uint32 _net_trust_dom_list(PRS_HANDLE *con_hnd, const UNISTR2 *uni_server_name,
			   BUFFER2 * uni_trust_dom_name);
uint32 _net_req_chal(PRS_HANDLE *con_hnd, const UNISTR2 *uni_logon_server,
		     const UNISTR2 *uni_logon_client,
		     const DOM_CHAL * clnt_chal, DOM_CHAL * srv_chal);
uint32 _net_auth(PRS_HANDLE *con_hnd, const UNISTR2 *uni_logon_srv,
		 const UNISTR2 *uni_acct_name,
		 uint16 sec_chan,
		 const UNISTR2 *uni_comp_name,
		 const DOM_CHAL * clnt_chal, DOM_CHAL * srv_chal);
uint32 _net_auth_2(PRS_HANDLE *con_hnd, const UNISTR2 *uni_logon_srv,
		   const UNISTR2 *uni_acct_name,
		   uint16 sec_chan,
		   const UNISTR2 *uni_comp_name,
		   const DOM_CHAL * clnt_chal,
		   const NEG_FLAGS * clnt_flgs,
		   DOM_CHAL * srv_chal, NEG_FLAGS * srv_flgs);
uint32 _net_srv_pwset(PRS_HANDLE *con_hnd, const UNISTR2 *uni_logon_srv,
		      const UNISTR2 *uni_acct_name,
		      uint16 sec_chan,
		      const UNISTR2 *uni_comp_name,
		      const DOM_CRED * clnt_cred,
		      const uint8 pwd[16], DOM_CRED * srv_cred);
uint32 _net_sam_logon(PRS_HANDLE *con_hnd, const UNISTR2 *uni_logon_srv,
		      const UNISTR2 *uni_comp_name,
		      const DOM_CRED * clnt_cred,
		      uint16 logon_level,
		      const NET_ID_INFO_CTR * id_ctr,
		      uint16 validation_level,
		      DOM_CRED * srv_creds,
		      NET_USER_INFO_CTR * uctr, uint32 *auth_resp);
uint32 _net_sam_logoff(PRS_HANDLE *con_hnd, const DOM_SAM_INFO * sam_id, DOM_CRED * srv_creds);
uint32 _net_sam_sync(PRS_HANDLE *con_hnd, const UNISTR2 *uni_srv_name,
		     const UNISTR2 *uni_cli_name,
		     DOM_CRED * cli_creds,
		     DOM_CRED * srv_creds,
		     uint32 database_id,
		     uint32 restart_state,
		     uint32 *sync_context,
		     uint32 max_size,
		     uint32 *num_deltas,
		     uint32 *num_deltas2,
		     SAM_DELTA_HDR * hdr_deltas, SAM_DELTA_CTR * deltas);

/*The following definitions come from  passdb/pass_check.c  */

void dfs_unlogin(void);
BOOL pass_check(const char *_user, const char *_password,
		int pwlen, const struct passwd *pwd,
		BOOL (*fn) (const char *, const char *));

/*The following definitions come from  passdb/secrets.c  */

BOOL secrets_init(void);
void *secrets_fetch(char *key, size_t *size);
BOOL secrets_store(char *key, void *data, size_t size);
BOOL secrets_delete(char *key);
BOOL secrets_store_domain_sid(char *domain, DOM_SID *sid);
BOOL secrets_fetch_domain_sid(char *domain, DOM_SID *sid);

/*The following definitions come from  printing/load.c  */

void load_printers(void);

/*The following definitions come from  printing/lpq_parse.c  */

BOOL parse_lpq_entry(int snum,char *line,
		     print_queue_struct *buf,
		     print_status_struct *status,BOOL first);

/*The following definitions come from  printing/nt_printing.c  */

BOOL nt_printing_init(void);
int get_ntforms(nt_forms_struct **list);
int write_ntforms(nt_forms_struct **list, int number);
BOOL add_a_form(nt_forms_struct **list, const FORM *form, int *count);
void update_a_form(nt_forms_struct **list, const FORM *form, int count);
int get_ntdrivers(fstring **list, char *architecture);
BOOL get_short_archi(char *short_archi, char *long_archi);
void clean_up_driver_struct(NT_PRINTER_DRIVER_INFO_LEVEL driver_abstract, uint32 level);
uint32 del_a_printer(char *portname);
BOOL add_a_specific_param(NT_PRINTER_INFO_LEVEL_2 *info_2, NT_PRINTER_PARAM *param);
BOOL unlink_specific_param_if_exist(NT_PRINTER_INFO_LEVEL_2 *info_2, NT_PRINTER_PARAM *param);
NT_DEVICEMODE *init_devicemode(NT_DEVICEMODE *nt_devmode);
NT_DEVICEMODE *dup_nt_devicemode(NT_DEVICEMODE *nt_devicemode);
void free_nt_devicemode(NT_DEVICEMODE **devmode_ptr);
void get_printer_subst_params(int snum, fstring *printername, fstring *sharename, fstring *portname);
uint32 add_a_printer(NT_PRINTER_INFO_LEVEL printer, uint32 level);
uint32 get_a_printer(NT_PRINTER_INFO_LEVEL *printer, uint32 level, fstring sharename);
uint32 free_a_printer(NT_PRINTER_INFO_LEVEL **pp_printer, uint32 level);
uint32 add_a_printer_driver(NT_PRINTER_DRIVER_INFO_LEVEL driver, uint32 level);
uint32 get_a_printer_driver(NT_PRINTER_DRIVER_INFO_LEVEL *driver, uint32 level,
                            fstring printername, fstring architecture);
uint32 free_a_printer_driver(NT_PRINTER_DRIVER_INFO_LEVEL driver, uint32 level);
BOOL get_specific_param_by_index(NT_PRINTER_INFO_LEVEL printer, uint32 level, uint32 param_index,
                                 fstring value, uint8 **data, uint32 *type, uint32 *len);
BOOL get_specific_param(NT_PRINTER_INFO_LEVEL printer, uint32 level,
                        fstring value, uint8 **data, uint32 *type, uint32 *len);
uint32 nt_printing_setsec(char *printername, SEC_DESC_BUF *secdesc_ctr);
uint32 nt_printing_getsec(char *printername, SEC_DESC_BUF *secdesc_ctr);
BOOL print_time_access_check(int snum);

/*The following definitions come from  printing/pcap.c  */

BOOL pcap_printername_ok(char *pszPrintername, char *pszPrintcapname);
void pcap_printer_fn(void (*fn)(char *, char *));

/*The following definitions come from  printing/print_cups.c  */

void cups_printer_fn(void (*fn)(char *, char *));
int cups_printername_ok(char *name);

/*The following definitions come from  printing/print_svid.c  */

void sysv_printer_fn(void (*fn)(char *, char *));
int sysv_printername_ok(char *name);

/*The following definitions come from  printing/printfsp.c  */

files_struct *print_fsp_open(connection_struct *conn,char *jobname);
void print_fsp_end(files_struct *fsp);

/*The following definitions come from  printing/printing.c  */

BOOL print_backend_init(void);
BOOL print_job_exists(int jobid);
int print_job_snum(int jobid);
int print_job_fd(int jobid);
char *print_job_fname(int jobid);
BOOL print_job_set_place(int jobid, int place);
BOOL print_job_set_name(int jobid, char *name);
BOOL print_job_delete(int jobid);
BOOL print_job_pause(int jobid);
BOOL print_job_resume(int jobid);
int print_job_write(int jobid, const char *buf, int size);
int print_job_start(int snum, char *jobname);
BOOL print_job_end(int jobid);
int print_queue_status(int snum,
		       print_queue_struct **queue,
		       print_status_struct *status);
int print_queue_snum(char *qname);
BOOL print_queue_pause(int snum);
BOOL print_queue_resume(int snum);
BOOL print_queue_purge(int snum);

/*The following definitions come from  profile/profile.c  */

BOOL profile_setup(BOOL rdonly);

/*The following definitions come from  rpc_client/cli_netlogon_sync.c  */

BOOL synchronise_passdb(void);

/*The following definitions come from  rpc_client/msrpc_spoolss.c  */

BOOL msrpc_spoolss_enum_printers(char* srv_name, uint32 flags, uint32 level, PRINTER_INFO_CTR ctr);
uint32 msrpc_spoolss_getprinterdata( const char* printer_name,
				const char* station,
				const char* user_name,
				const char* value_name,
				uint32 *type,
				NEW_BUFFER *buffer,
				void *fn);
BOOL msrpc_spoolss_enum_jobs( const char* printer_name,
				const char* station, const char* user_name,
				uint32 level,
				void ***ctr, JOB_INFO_FN(fn));
BOOL msrpc_spoolss_enum_printerdata( const char* printer_name,
		const char* station, const char* user_name );
BOOL msrpc_spoolss_getprinter( const char* printer_name, const uint32 level,
		const char* station, const char* user_name,
		PRINTER_INFO_CTR ctr);
BOOL msrpc_spoolss_getprinterdriver( const char* printer_name,
		const char *environment, const uint32 level,
		const char* station, const char* user_name,
		PRINTER_DRIVER_CTR ctr);
BOOL msrpc_spoolss_enumprinterdrivers( const char* srv_name,
		const char *environment, const uint32 level,
		PRINTER_DRIVER_CTR ctr);
BOOL msrpc_spoolss_getprinterdriverdir(char* srv_name, char* env_name, uint32 level, DRIVER_DIRECTORY_CTR ctr);

/*The following definitions come from  rpc_server/srv_brs.c  */

BOOL api_brs_rpc(rpcsrv_struct * p);

/*The following definitions come from  rpc_server/srv_lookup.c  */

uint32 make_dom_gids(DOMAIN_GRP * mem, int num_members, DOM_GID ** ppgids);
uint32 lookup_sid(const DOM_SID *sid, char *name, uint32 *type);
uint32 lookup_name(const char *name, DOM_SID *sid, uint32 *type);

/*The following definitions come from  rpc_server/srv_netlog.c  */

BOOL api_netlog_rpc(rpcsrv_struct * p);

/*The following definitions come from  rpc_server/srv_pipe.c  */

BOOL read_then_write_pipe(pipes_struct * p, char *data, int len,
		    char **rdata, int *rlen, BOOL *pipe_outstanding);
ssize_t write_to_pipe(pipes_struct * p, char *data, size_t n);
int read_from_pipe(pipes_struct * p, char *data, int max_len);

/*The following definitions come from  rpc_server/srv_pipe_hnd.c  */

void set_pipe_handle_offset(int max_open_files);
void reset_chain_p(void);
void init_rpc_pipe_hnd(void);
pipes_struct *open_rpc_pipe_p(char *pipe_name, uint16 vuid,
			      rpcsrv_struct * l);
BOOL wait_rpc_pipe_hnd_state(pipes_struct * p, uint16 priority);
BOOL set_rpc_pipe_hnd_state(pipes_struct * p, uint16 device_state);
BOOL close_rpc_pipe_hnd(pipes_struct * p);
pipes_struct *get_rpc_pipe_p(char *buf, int where);
pipes_struct *get_rpc_pipe(int pnum);

/*The following definitions come from  rpc_server/srv_pipe_netsec.c  */


/*The following definitions come from  rpc_server/srv_pipe_noauth.c  */


/*The following definitions come from  rpc_server/srv_pipe_ntlmssp.c  */


/*The following definitions come from  rpc_server/srv_pipe_srv.c  */

void close_msrpc_command_processor(void);
void add_msrpc_command_processor(char *pipe_name,
				 char *process_name,
				 BOOL (*fn) (rpcsrv_struct *),
				 const RPC_IFACE *abstract);
BOOL api_rpcTNP(rpcsrv_struct * l, const char *rpc_name,
		const struct api_struct *api_rpc_cmds);
BOOL rpc_local(rpcsrv_struct * l, char *data, int len, const char *name);

/*The following definitions come from  rpc_server/srv_reg.c  */

BOOL api_reg_rpc(rpcsrv_struct * p);

/*The following definitions come from  rpc_server/srv_samr.c  */

BOOL api_samr_rpc(rpcsrv_struct * p);

/*The following definitions come from  rpc_server/srv_spoolss.c  */

BOOL api_spoolss_rpc(rpcsrv_struct * p);

/*The following definitions come from  rpc_server/srv_srvsvc.c  */

BOOL api_srvsvc_rpc(rpcsrv_struct * p);

/*The following definitions come from  rpc_server/srv_svcctl.c  */

BOOL api_svcctl_rpc(rpcsrv_struct * p);

/*The following definitions come from  rpc_server/srv_wkssvc.c  */

BOOL api_wkssvc_rpc(rpcsrv_struct * p);

/*The following definitions come from  rpcclient/cmd_atsvc.c  */

uint32 cmd_at(struct client_info *info, int argc, char *argv[]);

/*The following definitions come from  rpcclient/cmd_brs.c  */

void cmd_brs_query_info(struct client_info *info, int argc, char *argv[]);
uint32 cmd_brs_query_stats(struct client_info *info, int argc, char *argv[]);

/*The following definitions come from  rpcclient/cmd_dfs.c  */

void cmd_dfs_add(struct client_info *info, int argc, char *argv[]);
void cmd_dfs_remove(struct client_info *info, int argc, char *argv[]);
void cmd_dfs_enum(struct client_info *info, int argc, char *argv[]);

/*The following definitions come from  rpcclient/cmd_eventlog.c  */

uint32 cmd_eventlog(struct client_info *info, int argc, char *argv[]);

/*The following definitions come from  rpcclient/cmd_lsarpc.c  */

void cmd_lsa_enum_trust_dom(struct client_info *info, int argc, char *argv[]);
uint32 cmd_lsa_query_info(struct client_info *info, int argc, char *argv[]);
void cmd_lsa_lookup_names(struct client_info *info, int argc, char *argv[]);
void cmd_lsa_lookup_sids(struct client_info *info, int argc, char *argv[]);
void cmd_lsa_set_secret(struct client_info *info, int argc, char *argv[]);
void cmd_lsa_create_secret(struct client_info *info, int argc, char *argv[]);
uint32 cmd_lsa_show_sd(struct client_info *info, int argc, char *argv[]);
uint32 cmd_lsa_query_secret(struct client_info *info, int argc, char *argv[]);
uint32 cmd_lsa_enum_privs(struct client_info *info, int argc, char *argv[]);
uint32 cmd_lsa_priv_info(struct client_info *info, int argc, char *argv[]);
uint32 cmd_lsa_enum_sids(struct client_info *info, int argc, char *argv[]);
uint32 cmd_lsa_query_trust_info(struct client_info *info, int argc, char *argv[]);

/*The following definitions come from  rpcclient/cmd_netlogon.c  */

void cmd_netlogon_pwset(struct client_info *info, int argc, char *argv[]);
uint32 cmd_netlogon_dom_list(struct client_info *info, int argc, char *argv[]);
uint32 cmd_netlogon_login_test(struct client_info *info, int argc, char *argv[]);
uint32 cmd_netlogon_domain_test(struct client_info *info,
				int argc, char *argv[]);
uint32 cmd_sam_sync(struct client_info *info, int argc, char *argv[]);

/*The following definitions come from  rpcclient/cmd_reg.c  */

void split_server_keyname(char *srv_name, char *key, const char* arg);
BOOL msrpc_reg_enum_key(const char* srv_name, const char* full_keyname,
				REG_FN(reg_fn),
				REG_KEY_FN(reg_key_fn),
				REG_VAL_FN(reg_val_fn));
uint32 cmd_reg_enum(struct client_info *info, int argc, char *argv[]);
void cmd_reg_query_info(struct client_info *info, int argc, char *argv[]);
void cmd_reg_query_key(struct client_info *info, int argc, char *argv[]);
uint32 cmd_reg_create_val(struct client_info *info, int argc, char *argv[]);
void cmd_reg_delete_val(struct client_info *info, int argc, char *argv[]);
void cmd_reg_delete_key(struct client_info *info, int argc, char *argv[]);
void cmd_reg_create_key(struct client_info *info, int argc, char *argv[]);
void cmd_reg_test_key_sec(struct client_info *info, int argc, char *argv[]);
void cmd_reg_get_key_sec(struct client_info *info, int argc, char *argv[]);
void cmd_reg_shutdown(struct client_info *info, int argc, char *argv[]);
void cmd_reg_abort_shutdown(struct client_info *info, int argc, char *argv[]);

/*The following definitions come from  rpcclient/cmd_samr.c  */

uint32 cmd_sam_ntchange_pwd(struct client_info *info, int argc, char *argv[]);
uint32 cmd_sam_test(struct client_info *info, int argc, char *argv[]);
uint32 cmd_sam_lookup_domain(struct client_info *info, int argc, char *argv[]);
uint32 cmd_sam_lookup_names(struct client_info *info, int argc, char *argv[]);
uint32 cmd_sam_lookup_rids(struct client_info *info, int argc, char *argv[]);
uint32 cmd_sam_del_aliasmem(struct client_info *info, int argc, char *argv[]);
uint32 cmd_sam_delete_dom_alias(struct client_info *info, int argc,
			      char *argv[]);
uint32 cmd_sam_add_aliasmem(struct client_info *info, int argc, char *argv[]);
uint32 cmd_sam_create_dom_trusting(struct client_info *info, int argc,
				 char *argv[]);
uint32 cmd_sam_create_dom_user(struct client_info *info, int argc, char *argv[]);
uint32 cmd_sam_create_dom_alias(struct client_info *info, int argc,
			      char *argv[]);
uint32 cmd_sam_del_groupmem(struct client_info *info, int argc, char *argv[]);
uint32 cmd_sam_delete_dom_user(struct client_info *info, int argc, char *argv[]);
uint32 cmd_sam_delete_dom_group(struct client_info *info, int argc,
			      char *argv[]);
uint32 cmd_sam_add_groupmem(struct client_info *info, int argc, char *argv[]);
uint32 cmd_sam_create_dom_group(struct client_info *info, int argc,
			      char *argv[]);
uint32 cmd_sam_enum_users(struct client_info *info, int argc, char *argv[]);
uint32 cmd_sam_query_groupmem(struct client_info *info, int argc, char *argv[]);
uint32 cmd_sam_query_group(struct client_info *info, int argc, char *argv[]);
uint32 cmd_sam_query_sec_obj(struct client_info *info, int argc, char *argv[]);
uint32 cmd_sam_query_user(struct client_info *info, int argc, char *argv[]);
uint32 cmd_sam_set_userinfo2(struct client_info *info, int argc, char *argv[]);
uint32 cmd_sam_set_userinfo(struct client_info *info, int argc, char *argv[]);
uint32 cmd_sam_query_dispinfo(struct client_info *info, int argc, char *argv[]);
uint32 cmd_sam_query_dominfo(struct client_info *info, int argc, char *argv[]);
uint32 cmd_sam_query_aliasmem(struct client_info *info, int argc, char *argv[]);
uint32 cmd_sam_query_alias(struct client_info *info, int argc, char *argv[]);
uint32 cmd_sam_enum_aliases(struct client_info *info, int argc, char *argv[]);
uint32 cmd_sam_enum_groups(struct client_info *info, int argc, char *argv[]);
uint32 cmd_sam_enum_domains(struct client_info *info, int argc, char *argv[]);

/*The following definitions come from  rpcclient/cmd_spoolss.c  */

uint32 cmd_spoolss_enum_printers(struct client_info *info, int argc, char *argv[]);
uint32 cmd_spoolss_open_printer_ex(struct client_info *info, int argc, char *argv[]);
uint32 cmd_spoolss_getprinterdata(struct client_info *info, int argc, char *argv[]);
uint32 cmd_spoolss_enum_jobs(struct client_info *info, int argc, char *argv[]);
uint32 cmd_spoolss_enum_printerdata(struct client_info *info, int argc, char *argv[]);
uint32 cmd_spoolss_getprinter(struct client_info *info, int argc, char *argv[]);
uint32 cmd_spoolss_getprinterdriver(struct client_info *info, int argc, char *argv[]);
uint32 cmd_spoolss_enumprinterdrivers(struct client_info *info, int argc, char *argv[]);
uint32 cmd_spoolss_getprinterdriverdir(struct client_info *info, int argc, char *argv[]);

/*The following definitions come from  rpcclient/cmd_srvsvc.c  */

void cmd_srv_query_info(struct client_info *info, int argc, char *argv[]);
void cmd_srv_enum_tprt(struct client_info *info, int argc, char *argv[]);
void cmd_srv_enum_conn(struct client_info *info, int argc, char *argv[]);
void cmd_srv_enum_shares(struct client_info *info, int argc, char *argv[]);
uint32 cmd_srv_share_get_info(struct client_info *info, int argc, char *argv[]);
uint32 cmd_srv_share_add(struct client_info *info, int argc, char *argv[]);
uint32 cmd_srv_share_del(struct client_info *info, int argc, char *argv[]);
void cmd_srv_enum_sess(struct client_info *info, int argc, char *argv[]);
void cmd_srv_enum_files(struct client_info *info, int argc, char *argv[]);
void cmd_time(struct client_info *info, int argc, char *argv[]);

/*The following definitions come from  rpcclient/cmd_svcctl.c  */

uint32 cmd_svc_info(struct client_info *info, int argc, char *argv[]);
BOOL msrpc_svc_enum(const char* srv_name,
				ENUM_SRVC_STATUS **svcs,
				uint32 *num_svcs,
				SVC_INFO_FN(info_fn),
				SVC_QUERY_FN(query_fn));
uint32 cmd_svc_enum(struct client_info *info, int argc, char *argv[]);
uint32 cmd_svc_stop(struct client_info *info, int argc, char *argv[]);
uint32 cmd_svc_start(struct client_info *info, int argc, char *argv[]);
uint32 cmd_svc_set(struct client_info *info, int argc, char *argv[]);
uint32 cmd_svc_unk3(struct client_info *info, int argc, char *argv[]);
uint32 cmd_svc_get_sec(struct client_info *info, int argc, char *argv[]);

/*The following definitions come from  rpcclient/cmd_wkssvc.c  */

void cmd_wks_query_info(struct client_info *info, int argc, char *argv[]);
uint32 cmd_wks_user_enum(struct client_info *info, int argc, char *argv[]);

/*The following definitions come from  rpcclient/cmdat.c  */


/*The following definitions come from  rpcclient/cmdat_cmds.c  */

void add_at_commands(void);

/*The following definitions come from  rpcclient/dfs_cmds.c  */

void add_dfs_commands(void);

/*The following definitions come from  rpcclient/display_at.c  */

void display_at_enum_info(FILE *out_hnd, enum action_type action,
				uint32 num_jobs, const AT_ENUM_INFO *const jobs,
				char *const *const commands);
void display_at_job_info(FILE *out_hnd, enum action_type action,
		     AT_JOB_INFO *const job, fstring command);

/*The following definitions come from  rpcclient/display_dfs.c  */

void display_dfs_enum(FILE *hnd, char *srv_name, DFS_INFO_CTR *ctr);

/*The following definitions come from  rpcclient/display_event.c  */

void display_eventlog_eventrecord(FILE *out_hnd, enum action_type action, EVENTLOGRECORD *const ev);

/*The following definitions come from  rpcclient/display_misc.c  */

void display_nttime(FILE *out_hnd, const char *intro, const NTTIME *nttime);

/*The following definitions come from  rpcclient/display_reg.c  */

void display_reg_value_info(FILE *out_hnd, enum action_type action,
				const char *val_name,
				uint32 val_type, const BUFFER2 *value);
void display_reg_key_info(FILE *out_hnd, enum action_type action,
				const char *key_name, time_t key_mod_time);

/*The following definitions come from  rpcclient/display_sam.c  */

void display_alias_members(FILE *out_hnd, enum action_type action,
				uint32 num_mem, char *const *const sid_mem,
				uint32 *const type);
void display_group_members(FILE *out_hnd, enum action_type action,
				uint32 num_mem, char *const *const name, uint32 *const type);
void display_group_info_ctr(FILE *out_hnd, enum action_type action,
				GROUP_INFO_CTR *const ctr);
void display_alias_info_ctr(FILE *out_hnd, enum action_type action,
				ALIAS_INFO_CTR *const ctr);
void display_sam_user_info_21(FILE *out_hnd, enum action_type action, SAM_USER_INFO_21 *const usr);
void display_sam_unk_ctr(FILE *out_hnd, enum action_type action,
				uint32 switch_value, SAM_UNK_CTR *const ctr);
void display_sam_disp_info_ctr(FILE *out_hnd, enum action_type action,
				uint16 level, uint32 count,
				SAM_DISPINFO_CTR *const ctr);

/*The following definitions come from  rpcclient/display_sec.c  */

void print_sec_desc(const SEC_DESC *sd,
		    FILE *out_hnd, const char *ind_str,
		    int object_type, void *obj_masks,
		    const char *srv_name, const POLICY_HND *lsa_hnd);
void display_sec_desc(FILE *out_hnd, enum action_type action, SEC_DESC *const sec);

/*The following definitions come from  rpcclient/display_spool.c  */

void display_printer_info_ctr(FILE *out_hnd, enum action_type action, uint32 level,
				uint32 count, PRINTER_INFO_CTR ctr);
void display_printer_enumdata(FILE *out_hnd, enum action_type action, uint32 idx,
				uint32 valuelen, uint16 *value, uint32 rvaluelen,
				uint32 type,
				uint32 datalen, uint8 *data, uint32 rdatalen);
void display_job_info_ctr(FILE *out_hnd, enum action_type action,
				uint32 level, uint32 count,
				void *const *const ctr);
void display_printer_driver_ctr(FILE *out_hnd, enum action_type action, uint32 level,
				uint32 count, PRINTER_DRIVER_CTR ctr);
void display_printerdriverdir_info_ctr(FILE *out_hnd, enum action_type action, uint32 level,
				DRIVER_DIRECTORY_CTR ctr);

/*The following definitions come from  rpcclient/display_srv.c  */

void display_srv_info_ctr(FILE * out_hnd, enum action_type action,
			  const SRV_INFO_CTR * ctr);
void display_srv_conn_info_ctr(FILE * out_hnd, enum action_type action,
			       SRV_CONN_INFO_CTR * const ctr);
void display_srv_tprt_info_ctr(FILE * out_hnd, enum action_type action,
			       const SRV_TPRT_INFO_CTR * const ctr);
void display_srv_share_info_ctr(FILE * out_hnd, enum action_type action,
				SRV_SHARE_INFO_CTR * const ctr);
void display_share_info_ctr(FILE * out_hnd, enum action_type action,
			    SHARE_INFO_CTR * const ctr);
void display_srv_file_info_ctr(FILE * out_hnd, enum action_type action,
			       SRV_FILE_INFO_CTR * const ctr);
void display_srv_sess_info_ctr(FILE * out_hnd, enum action_type action,
			       SRV_SESS_INFO_CTR * const ctr);

/*The following definitions come from  rpcclient/display_svc.c  */

void display_query_svc_cfg(FILE *out_hnd, enum action_type action,
				const QUERY_SERVICE_CONFIG *const cfg);
void display_svc_info(FILE *out_hnd, enum action_type action,
				const ENUM_SRVC_STATUS *const svc);
void display_svc_name(FILE *out_hnd, enum action_type action,
				const ENUM_SRVC_STATUS *const svc);

/*The following definitions come from  rpcclient/display_sync.c  */

void display_sam_sync(FILE *out_hnd, enum action_type action,
				SAM_DELTA_HDR *const deltas,
				SAM_DELTA_CTR *const ctr,
				uint32 num);

/*The following definitions come from  rpcclient/display_wks.c  */

void display_wks_info_100(FILE * out_hnd, enum action_type action,
			  const WKS_INFO_100 * const svc);

/*The following definitions come from  rpcclient/eventlog.c  */

int main(int argc, char *argv[]);

/*The following definitions come from  rpcclient/eventlog_cmds.c  */

void add_evt_commands(void);

/*The following definitions come from  rpcclient/lsa.c  */


/*The following definitions come from  rpcclient/lsa_cmds.c  */

void add_lsa_commands(void);

/*The following definitions come from  rpcclient/net.c  */


/*The following definitions come from  rpcclient/net_cmds.c  */

void add_net_commands(void);

/*The following definitions come from  rpcclient/netlogon_cmds.c  */

void add_ntl_commands(void);

/*The following definitions come from  rpcclient/regedit.c  */


/*The following definitions come from  rpcclient/regedit_cmds.c  */

void add_reg_commands(void);

/*The following definitions come from  rpcclient/rpcclient.c  */


/*The following definitions come from  rpcclient/samedit.c  */


/*The following definitions come from  rpcclient/samedit_cmds.c  */

void add_sam_commands(void);

/*The following definitions come from  rpcclient/spoolss.c  */

int main(int argc, char *argv[]);

/*The following definitions come from  rpcclient/spoolss_cmds.c  */

void add_spl_commands(void);

/*The following definitions come from  rpcclient/svcctrl.c  */

int main(int argc, char *argv[]);

/*The following definitions come from  rpcclient/svcctrl_cmds.c  */

void add_svc_commands(void);

/*The following definitions come from  samrd/samr_util.c  */

uint32 samr_make_usr_obj_sd(SEC_DESC_BUF *buf, DOM_SID *usr_sid,
			    BOOL pw_can_change);

/*The following definitions come from  samrd/samrd.c  */

msrpc_service_fns *get_service_fns(void);

/*The following definitions come from  samrd/srv_samr_als_tdb.c  */

uint32 _samr_add_aliasmem(const POLICY_HND *alias_pol, const DOM_SID *sid);
uint32 _samr_del_aliasmem(const POLICY_HND *alias_pol, const DOM_SID *sid);
uint32 _samr_query_aliasinfo(const POLICY_HND *alias_pol,
				uint16 switch_level,
				ALIAS_INFO_CTR *ctr);
uint32 _samr_set_aliasinfo(POLICY_HND *alias_pol, uint16 switch_level,
			   ALIAS_INFO_CTR *ctr);
uint32 _samr_delete_dom_alias(POLICY_HND *alias_pol);
uint32 _samr_query_aliasmem(const POLICY_HND *alias_pol,
				uint32 *num_mem, DOM_SID2 **sid);
uint32 _samr_create_dom_alias(const POLICY_HND *domain_pol,
				const UNISTR2 *uni_acct_name,
				uint32 access_mask,
				POLICY_HND *alias_pol, uint32 *rid);
uint32 _samr_open_alias(const POLICY_HND *domain_pol,
					uint32 access_mask, uint32 alias_rid,
					POLICY_HND *alias_pol);

/*The following definitions come from  samrd/srv_samr_dom_nt5ldap.c  */

uint32 _samr_open_domain(const POLICY_HND *connect_pol,
				uint32 ace_perms,
				const DOM_SID *sid,
				POLICY_HND *domain_pol);
uint32 _samr_enum_dom_users(  const POLICY_HND *pol, uint32 *start_idx,
				uint16 acb_mask, uint16 unk_1, uint32 size,
				SAM_ENTRY **sam,
				UNISTR2 **uni_acct_name,
				uint32 *num_sam_users);
uint32 _samr_enum_dom_groups(const POLICY_HND *pol,
				uint32 *start_idx, uint32 size,
				SAM_ENTRY **sam,
				UNISTR2 **uni_acct_name,
				uint32 *num_sam_groups);
uint32 _samr_enum_dom_aliases(const POLICY_HND *pol,
					uint32 *start_idx, uint32 size,
					SAM_ENTRY **sam,
					UNISTR2 **uni_acct_name,
					uint32 *num_sam_aliases);
uint32 _samr_query_dispinfo(  const POLICY_HND *domain_pol, uint16 level,
					uint32 start_idx,
					uint32 max_entries,
					uint32 max_size,
					uint32 *data_size,
					uint32 *num_entries,
					SAM_DISPINFO_CTR *ctr);
uint32 _samr_lookup_names(const POLICY_HND *dom_pol,

			uint32 num_names,
			uint32 flags,
			uint32 ptr,
			const UNISTR2 *uni_name,

			uint32 *num_rids,
			uint32 rid[MAX_SAM_ENTRIES],
			uint32 *num_types,
			uint32 type[MAX_SAM_ENTRIES]);
uint32 _samr_lookup_rids(const POLICY_HND *dom_pol,
				uint32 num_rids, uint32 flags,
				const uint32 *rids,
				uint32 *num_names,
				UNIHDR **hdr_name, UNISTR2** uni_name,
				uint32 **types);
uint32 _samr_query_dom_info(const POLICY_HND *domain_pol,
				uint16 switch_value,
				SAM_UNK_CTR *ctr);
uint32 _samr_set_groupinfo(const POLICY_HND *pol,
				uint16 switch_level,
				const GROUP_INFO_CTR* ctr);
uint32 _samr_unknown_2d(const POLICY_HND *domain_pol, const DOM_SID *sid);

/*The following definitions come from  samrd/srv_samr_dom_tdb.c  */

uint32 _samr_open_domain(const POLICY_HND *connect_pol,
			 uint32 ace_perms,
			 const DOM_SID * sid, POLICY_HND *domain_pol);
uint32 _samr_enum_dom_users(const POLICY_HND *pol, uint32 * start_idx,
			    uint16 acb_mask, uint16 unk_1, uint32 size,
			    SAM_ENTRY ** sam,
			    UNISTR2 ** uni_acct_name, uint32 * num_sam_users);
uint32 _samr_enum_dom_groups(const POLICY_HND *pol,
			     uint32 * start_idx, uint32 size,
			     SAM_ENTRY ** sam,
			     UNISTR2 ** uni_acct_name,
			     uint32 * num_sam_groups);
uint32 _samr_enum_dom_aliases(const POLICY_HND *pol,
			      uint32 * start_idx, uint32 size,
			      SAM_ENTRY ** sam,
			      UNISTR2 ** uni_acct_name,
			      uint32 * num_sam_aliases);
uint32 _samr_query_dispinfo(const POLICY_HND *domain_pol, uint16 level,
			    uint32 start_idx,
			    uint32 max_entries,
			    uint32 max_size,
			    uint32 * data_size,
			    uint32 * num_entries, SAM_DISPINFO_CTR * ctr);
BOOL dom_user_traverse(const DOM_SID * dom_sid,
		       int (*fn) (TDB_CONTEXT *, void *), void *state);
uint32 _samr_lookup_names(const POLICY_HND *dom_pol,
			  uint32 num_names,
			  uint32 flags,
			  uint32 ptr,
			  const UNISTR2 * uni_name,
			  uint32 * num_rids,
			  uint32 rid[MAX_SAM_ENTRIES],
			  uint32 * num_types, uint32 type[MAX_SAM_ENTRIES]);
uint32 _samr_lookup_rids(const POLICY_HND *dom_pol,
			 uint32 num_rids, uint32 flags,
			 const uint32 * rids,
			 uint32 * num_names,
			 UNIHDR ** hdr_name, UNISTR2 ** uni_name,
			 uint32 ** types);
uint32 _samr_query_dom_info(const POLICY_HND *domain_pol,
			    uint16 switch_value, SAM_UNK_CTR * ctr);
uint32 _samr_unknown_2d(const POLICY_HND *domain_pol, const DOM_SID * sid);

/*The following definitions come from  samrd/srv_samr_grp_tdb.c  */

uint32 _samr_add_groupmem(const POLICY_HND *pol, uint32 rid, uint32 unknown);
uint32 _samr_del_groupmem(const POLICY_HND *pol, uint32 rid);
uint32 _samr_delete_dom_group(POLICY_HND *group_pol);
uint32 _samr_query_groupmem(const POLICY_HND *group_pol,
			    uint32 * num_mem, uint32 ** rid, uint32 ** attr);
uint32 _samr_set_groupinfo(const POLICY_HND *pol,
			   uint16 switch_level, const GROUP_INFO_CTR * ctr);
uint32 _samr_query_groupinfo(const POLICY_HND *pol,
			     uint16 switch_level, GROUP_INFO_CTR * ctr);
uint32 _samr_create_dom_group(const POLICY_HND *domain_pol,
			      const UNISTR2 * uni_acct_name,
			      uint32 access_mask,
			      POLICY_HND *group_pol, uint32 * group_rid);
uint32 _samr_open_group(const POLICY_HND *domain_pol, uint32 access_mask,
			uint32 group_rid, POLICY_HND *group_pol);

/*The following definitions come from  samrd/srv_samr_nt5ldap.c  */

BOOL set_nt5ldaprid(struct policy_cache *cache, POLICY_HND *hnd,
				LDAPDB *hds, uint32 rid);
BOOL get_nt5ldaprid(struct policy_cache *cache, const POLICY_HND *hnd,
				LDAPDB **hds, uint32 *rid);
BOOL set_nt5ldapsam(struct policy_cache *cache, POLICY_HND *hnd,
				LDAPDB *hds);
BOOL get_nt5ldapsam(struct policy_cache *cache, const POLICY_HND *hnd,
				LDAPDB **hds);
BOOL set_nt5ldapdomsid(struct policy_cache *cache, POLICY_HND *hnd,
				LDAPDB *hds,
				const DOM_SID *sid);
BOOL get_nt5ldapdomsid(struct policy_cache *cache, const POLICY_HND *hnd,
				LDAPDB **hds,
				DOM_SID *sid);
BOOL set_nt5ldapsid(struct policy_cache *cache, POLICY_HND *hnd,
				LDAPDB *hds, const DOM_SID *sid);
BOOL get_nt5ldapsid(struct policy_cache *cache, const POLICY_HND *hnd,
				LDAPDB **hds, DOM_SID *sid);
uint32 samr_open_by_nt5ldaprid( LDAPDB *hds,
				const POLICY_HND *parent_pol,
				POLICY_HND *pol, uint32 access_mask, uint32 rid);
BOOL pwdbsam_initialise(void);

/*The following definitions come from  samrd/srv_samr_passdb.c  */

uint32 _samr_close(POLICY_HND * hnd);
uint32 _samr_unknown_2d(const POLICY_HND * domain_pol, const DOM_SID * sid);
uint32 _samr_open_domain(const POLICY_HND * connect_pol,
			 uint32 ace_perms,
			 const DOM_SID * sid, POLICY_HND * domain_pol);
uint32 _samr_get_usrdom_pwinfo(const POLICY_HND * user_pol,
			       uint16 * unknown_0,
			       uint16 * unknown_1, uint32 * unknown_2);
uint32 _samr_query_sec_obj(const POLICY_HND *hnd, SEC_DESC_BUF * buf);
uint32 _samr_set_sec_object(POLICY_HND *hnd, uint32 sec_info,
			    SEC_DESC_BUF * buf);
uint32 _samr_enum_dom_users(const POLICY_HND * pol, uint32 * start_idx,
			    uint16 acb_mask, uint16 unk_1, uint32 size,
			    SAM_ENTRY ** sam,
			    UNISTR2 ** uni_acct_name, uint32 * num_sam_users);
uint32 _samr_add_groupmem(const POLICY_HND * pol, uint32 rid, uint32 unknown);
uint32 _samr_del_groupmem(const POLICY_HND * pol, uint32 rid);
uint32 _samr_add_aliasmem(const POLICY_HND * alias_pol, const DOM_SID * sid);
uint32 _samr_del_aliasmem(const POLICY_HND * alias_pol, const DOM_SID * sid);
uint32 _samr_enum_domains(const POLICY_HND * pol, uint32 * start_idx,
			  uint32 size,
			  SAM_ENTRY ** sam,
			  UNISTR2 ** uni_acct_name, uint32 * num_sam_users);
uint32 _samr_enum_dom_groups(const POLICY_HND * pol,
			     uint32 * start_idx, uint32 size,
			     SAM_ENTRY ** sam,
			     UNISTR2 ** uni_acct_name,
			     uint32 * num_sam_groups);
uint32 _samr_enum_dom_aliases(const POLICY_HND * pol,
			      uint32 * start_idx, uint32 size,
			      SAM_ENTRY ** sam,
			      UNISTR2 ** uni_acct_name,
			      uint32 * num_sam_aliases);
uint32 _samr_query_dispinfo(const POLICY_HND * domain_pol, uint16 level,
			    uint32 start_idx,
			    uint32 max_entries,
			    uint32 max_size,
			    uint32 * data_size,
			    uint32 * num_entries, SAM_DISPINFO_CTR * ctr);
uint32 _samr_delete_dom_user(POLICY_HND *user_pol);
uint32 _samr_delete_dom_group(POLICY_HND * group_pol);
uint32 _samr_query_groupmem(const POLICY_HND * group_pol,
			    uint32 * num_mem, uint32 ** rid, uint32 ** attr);
uint32 _samr_set_groupinfo(const POLICY_HND * pol,
			   uint16 switch_level, const GROUP_INFO_CTR * ctr);
uint32 _samr_query_groupinfo(const POLICY_HND * pol,
			     uint16 switch_level, GROUP_INFO_CTR * ctr);
uint32 _samr_query_aliasinfo(const POLICY_HND * alias_pol,
			     uint16 switch_level, ALIAS_INFO_CTR * ctr);
uint32 _samr_set_aliasinfo(POLICY_HND *alias_pol, uint16 switch_level,
			   ALIAS_INFO_CTR *ctr);
uint32 _samr_query_useraliases(const POLICY_HND * pol,
			       const uint32 * ptr_sid, const DOM_SID2 * sid,
			       uint32 * num_aliases, uint32 ** rid);
uint32 _samr_delete_dom_alias(POLICY_HND * alias_pol);
uint32 _samr_query_aliasmem(const POLICY_HND * alias_pol,
			    uint32 * num_mem, DOM_SID2 ** sid);
uint32 _samr_lookup_names(const POLICY_HND * pol,
			  uint32 num_names1,
			  uint32 flags,
			  uint32 ptr,
			  const UNISTR2 * uni_name,
			  uint32 * num_rids1,
			  uint32 rid[MAX_SAM_ENTRIES],
			  uint32 * num_types1, uint32 type[MAX_SAM_ENTRIES]);
uint32 _samr_chgpasswd_user(const UNISTR2 * uni_dest_host,
			    const UNISTR2 * uni_user_name,
			    const char nt_newpass[516],
			    const uchar nt_oldhash[16],
			    const char lm_newpass[516],
			    const uchar lm_oldhash[16]);
uint32 _samr_get_dom_pwinfo(const UNISTR2 * uni_srv_name,
			    uint16 * unk_0, uint16 * unk_1
#if 0
			    , uint16 * unk_2
#endif
			    );
uint32 _samr_lookup_rids(const POLICY_HND * pol,
			 uint32 num_rids, uint32 flags,
			 const uint32 * rids,
			 uint32 * num_names,
			 UNIHDR ** hdr_name, UNISTR2 ** uni_name,
			 uint32 ** types);
uint32 _samr_open_user(const POLICY_HND * domain_pol,
		       uint32 access_mask, uint32 user_rid,
		       POLICY_HND * user_pol);
uint32 _samr_query_userinfo(const POLICY_HND * pol, uint16 switch_value,
			    SAM_USERINFO_CTR * ctr);
uint32 _samr_set_userinfo(const POLICY_HND * pol, uint16 switch_value,
			  SAM_USERINFO_CTR * ctr);
uint32 _samr_set_userinfo2(const POLICY_HND * pol, uint16 switch_value,
			   SAM_USERINFO_CTR * ctr);
uint32 _samr_query_usergroups(const POLICY_HND * pol,
			      uint32 * num_groups, DOM_GID ** gids);
uint32 _samr_create_dom_alias(const POLICY_HND * domain_pol,
			      const UNISTR2 * uni_acct_name,
			      uint32 access_mask,
			      POLICY_HND * alias_pol, uint32 * rid);
uint32 _samr_create_dom_group(const POLICY_HND * domain_pol,
			      const UNISTR2 * uni_acct_name,
			      uint32 access_mask,
			      POLICY_HND * group_pol, uint32 * rid);
uint32 _samr_query_dom_info(const POLICY_HND * domain_pol,
			    uint16 switch_value, SAM_UNK_CTR * ctr);
uint32 _samr_create_user(const POLICY_HND * domain_pol,
			 const UNISTR2 * uni_username,
			 uint16 acb_info, uint32 access_mask,
			 POLICY_HND * user_pol,
			 uint32 * unknown_0, uint32 * user_rid);
uint32 _samr_connect_anon(const UNISTR2 * srv_name, uint32 access_mask,
			  POLICY_HND * connect_pol);
uint32 _samr_connect(const UNISTR2 * srv_name, uint32 access_mask,
		     POLICY_HND * connect_pol);
uint32 _samr_open_alias(const POLICY_HND * domain_pol,
			uint32 access_mask, uint32 alias_rid,
			POLICY_HND * alias_pol);
uint32 _samr_open_group(const POLICY_HND * domain_pol, uint32 access_mask,
			uint32 group_rid, POLICY_HND * group_pol);
uint32 _samr_lookup_domain(const POLICY_HND * connect_pol,
			   const UNISTR2 * uni_domain, DOM_SID * dom_sid);
BOOL pwdbsam_initialise(void);

/*The following definitions come from  samrd/srv_samr_sam_tdb.c  */

uint32 _samr_enum_domains(const POLICY_HND *pol, uint32 *start_idx,
				uint32 size,
				SAM_ENTRY **sam,
				UNISTR2 **uni_acct_name,
				uint32 *num_sam_users);
uint32 _samr_connect_anon(const UNISTR2 *srv_name, uint32 access_mask,
				POLICY_HND *connect_pol);
uint32 _samr_connect(const UNISTR2 *srv_name, uint32 access_mask,
				POLICY_HND *connect_pol);
uint32 _samr_lookup_domain(const POLICY_HND *connect_pol,
				const UNISTR2 *uni_domain,
				DOM_SID *dom_sid);
uint32 _samr_close(POLICY_HND *hnd);
uint32 _samr_chgpasswd_user( const UNISTR2 *uni_dest_host,
				const UNISTR2 *uni_user_name,
				const char nt_newpass[516],
				const uchar nt_oldhash[16],
				const char lm_newpass[516],
				const uchar lm_oldhash[16]);
uint32 _samr_get_dom_pwinfo(const UNISTR2 * uni_srv_name,
			    uint16 * unk_0, uint16 * unk_1
#if 0
			    , uint16 * unk_2
#endif
			    );
uint32 _samr_query_sec_obj(const POLICY_HND *pol, SEC_DESC_BUF *buf);

/*The following definitions come from  samrd/srv_samr_tdb.c  */

BOOL set_tdbrid(struct policy_cache *cache, POLICY_HND *hnd,
		TDB_CONTEXT * usr_tdb,
		TDB_CONTEXT * grp_tdb, TDB_CONTEXT * als_tdb, uint32 rid);
BOOL get_tdbrid(struct policy_cache *cache, const POLICY_HND *hnd,
		TDB_CONTEXT ** usr_tdb,
		TDB_CONTEXT ** grp_tdb, TDB_CONTEXT ** als_tdb, uint32 * rid);
BOOL set_tdbsam(struct policy_cache *cache, POLICY_HND *hnd,
		TDB_CONTEXT * tdb);
BOOL get_tdbsam(struct policy_cache *cache, const POLICY_HND *hnd,
		TDB_CONTEXT ** tdb);
BOOL set_tdbdomsid(struct policy_cache *cache, POLICY_HND *hnd,
		   TDB_CONTEXT * usr_tdb,
		   TDB_CONTEXT * usg_tdb,
		   TDB_CONTEXT * usa_tdb,
		   TDB_CONTEXT * grp_tdb,
		   TDB_CONTEXT * als_tdb, const DOM_SID * sid);
BOOL get_tdbdomsid(struct policy_cache *cache, const POLICY_HND *hnd,
		   TDB_CONTEXT ** usr_tdb,
		   TDB_CONTEXT ** usg_tdb,
		   TDB_CONTEXT ** usa_tdb,
		   TDB_CONTEXT ** grp_tdb,
		   TDB_CONTEXT ** als_tdb, DOM_SID * sid);
BOOL set_tdbsid(struct policy_cache *cache, POLICY_HND *hnd,
		TDB_CONTEXT * tdb, const DOM_SID * sid);
BOOL get_tdbsid(struct policy_cache *cache, const POLICY_HND *hnd,
		TDB_CONTEXT ** tdb, DOM_SID * sid);
TDB_CONTEXT *open_usr_db(const DOM_SID * sid, uint32 rid, int perms);
uint32 samr_open_user_tdb(const POLICY_HND *parent_pol,
			  const DOM_SID * sid,
			  TDB_CONTEXT * usr_tdb,
			  POLICY_HND *pol, uint32 ace_perms, uint32 rid);

/*The following definitions come from  samrd/srv_samr_tdb_init.c  */

uint32 initialise_dom_tdb(const DOM_SID * sid);
uint32 initialise_sam_tdb(const char *sam_name, const DOM_SID * sam_sid);
BOOL pwdbsam_initialise(void);

/*The following definitions come from  samrd/srv_samr_usr_nt5ldap.c  */

uint32 _samr_get_usrdom_pwinfo(const POLICY_HND *user_pol,
				uint16 *unknown_0,
				uint16 *unknown_1,
				uint32 *unknown_2);
uint32 _samr_query_sec_obj(const POLICY_HND *pol, SEC_DESC_BUF *buf);
uint32 _samr_query_usergroups(const POLICY_HND *pol,
				uint32 *num_groups,
				DOM_GID **gids);
uint32 _samr_query_useraliases(const POLICY_HND *pol,
				const uint32 *ptr_sid, const DOM_SID2 *sid,
				uint32 *num_aliases, uint32 **rid);
uint32 _samr_open_user(const POLICY_HND *domain_pol,
					uint32 access_mask, uint32 user_rid,
					POLICY_HND *user_pol);
uint32 _samr_query_userinfo(const POLICY_HND *pol, uint16 switch_value,
				SAM_USERINFO_CTR *ctr);
uint32 _samr_set_userinfo(const POLICY_HND *pol, uint16 switch_value,
				SAM_USERINFO_CTR *ctr);
uint32 _samr_set_userinfo2(const POLICY_HND *pol, uint16 switch_value,
				SAM_USERINFO_CTR *ctr);
uint32 _samr_create_user(const POLICY_HND *domain_pol,
				const UNISTR2 *uni_username,
				uint16 acb_info, uint32 access_mask,
				POLICY_HND *user_pol,
				uint32 *unknown_0, uint32 *user_rid);
uint32 _samr_delete_dom_user(POLICY_HND *user_pol);

/*The following definitions come from  samrd/srv_samr_usr_tdb.c  */

BOOL tdb_lookup_user(TDB_CONTEXT * tdb, SAM_USER_INFO_21 * usr);
uint32 _samr_get_usrdom_pwinfo(const POLICY_HND *user_pol,
			       uint16 *unknown_0,
			       uint16 *unknown_1, uint32 *unknown_2);
uint32 _samr_query_usergroups(const POLICY_HND *pol,
			      uint32 *num_groups, DOM_GID ** gids);
uint32 _samr_query_useraliases(const POLICY_HND *domain_pol,
			       const uint32 *ptr_sid, const DOM_SID2 * sid,
			       uint32 *num_aliases, uint32 **rid);
uint32 _samr_open_user(const POLICY_HND *domain_pol,
		       uint32 access_mask, uint32 user_rid,
		       POLICY_HND *user_pol);
uint32 _samr_query_userinfo(const POLICY_HND *pol, uint16 switch_value,
			    SAM_USERINFO_CTR * ctr);
uint32 _samr_set_userinfo(const POLICY_HND *pol, uint16 switch_value,
			  SAM_USERINFO_CTR * ctr);
uint32 _samr_set_userinfo2(const POLICY_HND *pol, uint16 switch_value,
			   SAM_USERINFO_CTR * ctr);
uint32 _samr_create_user(const POLICY_HND *domain_pol,
			 const UNISTR2 *uni_username,
			 uint16 acb_info, uint32 access_mask,
			 POLICY_HND *user_pol,
			 uint32 *unknown_0, uint32 *user_rid);
uint32 _samr_delete_dom_user(POLICY_HND *user_pol);

/*The following definitions come from  smbd/afsticket.c  */

int get_afs_ticket_from_srvtab(void);
pid_t get_renewed_ticket(connection_struct* conn);

/*The following definitions come from  smbd/auth_rhosts.c  */

BOOL check_hosts_equiv(char *user);

/*The following definitions come from  smbd/blocking.c  */

BOOL push_blocking_lock_request( char *inbuf, int length, int lock_timeout, int lock_num);
void remove_pending_lock_requests_by_fid(files_struct *fsp);
void remove_pending_lock_requests_by_mid(int mid);
BOOL blocking_locks_pending(void);
void process_blocking_lock_queue(time_t t);

/*The following definitions come from  smbd/challenge.c  */

void generate_next_challenge(char *challenge);
BOOL set_challenge(unsigned char *challenge);
BOOL last_challenge(unsigned char *challenge);

/*The following definitions come from  smbd/chgpasswd.c  */

uint32 pass_oem_change(const char *user,
		     const uchar * lmdata, const uchar * lmhash,
		     const uchar * ntdata, const uchar * nthash);
BOOL update_smbpassword_file(const char *user, const char *password);

/*The following definitions come from  smbd/close.c  */

int close_file(files_struct *fsp, BOOL normal_close);

/*The following definitions come from  smbd/conn.c  */

void conn_init(void);
int conn_num_open(void);
BOOL conn_snum_used(int snum);
connection_struct *conn_find(int cnum);
connection_struct *conn_new(void);
void conn_close_all(void);
BOOL conn_idle_all(time_t t, int deadtime);
void conn_free(connection_struct *conn);

/*The following definitions come from  smbd/connection.c  */

TDB_CONTEXT *conn_tdb_ctx(void);
BOOL yield_connection(connection_struct *conn,char *name,int max_connections);
BOOL claim_connection(connection_struct *conn,char *name,int max_connections,BOOL Clear);

/*The following definitions come from  smbd/dfree.c  */

SMB_BIG_UINT sys_disk_free(char *path, BOOL small_query,
                           SMB_BIG_UINT *bsize,SMB_BIG_UINT *dfree,SMB_BIG_UINT *dsize);

/*The following definitions come from  smbd/dir.c  */

void init_dptrs(void);
char *dptr_path(int key);
char *dptr_wcard(int key);
BOOL dptr_set_wcard(int key, char *wcard);
BOOL dptr_set_attr(int key, uint16 attr);
uint16 dptr_attr(int key);
void dptr_close(int *key);
void dptr_closecnum(connection_struct *conn);
void dptr_idlecnum(connection_struct *conn);
void dptr_closepath(char *path,uint16 spid);
int dptr_create(connection_struct *conn,char *path, BOOL old_handle, BOOL expect_close,uint16 spid);
BOOL dptr_fill(char *buf1,unsigned int key);
void *dptr_fetch(char *buf,int *num);
void *dptr_fetch_lanman2(int dptr_num);
BOOL dir_check_ftype(connection_struct *conn,int mode,SMB_STRUCT_STAT *st,int dirtype);
BOOL get_dir_entry(connection_struct *conn,char *mask,int dirtype,char *fname,
                   SMB_OFF_T *size,int *mode,time_t *date,BOOL check_descend);
void *OpenDir(connection_struct *conn, char *name, BOOL use_veto);
void CloseDir(void *p);
char *ReadDirName(void *p);
BOOL SeekDir(void *p,int pos);
int TellDir(void *p);
void DirCacheAdd( char *path, char *name, char *dname, int snum );
char *DirCacheCheck( char *path, char *name, int snum );
void DirCacheFlush(int snum);

/*The following definitions come from  smbd/dosmode.c  */

mode_t unix_mode(connection_struct *conn,int dosmode,const char *fname);
int dos_mode(connection_struct *conn,char *path,SMB_STRUCT_STAT *sbuf);
int file_chmod(connection_struct *conn,char *fname,int dosmode,SMB_STRUCT_STAT *st);
int file_utime(connection_struct *conn, char *fname, struct utimbuf *times);
BOOL set_filetime(connection_struct *conn, char *fname, time_t mtime);

/*The following definitions come from  smbd/error.c  */

int cached_error_packet(char *inbuf,char *outbuf,files_struct *fsp,int line);
int unix_error_packet(char *inbuf,char *outbuf,int def_class,uint32 def_code,int line);
int error_packet(char *inbuf,char *outbuf,int error_class,uint32 error_code,int line);
int error_packet_nt(char *inbuf, char *outbuf, uint32 ntstatus,
		    const char *file, int line);

/*The following definitions come from  smbd/fileio.c  */

ssize_t read_file(files_struct *fsp,char *data,SMB_OFF_T pos,size_t n);
ssize_t write_file(files_struct *fsp, char *data, SMB_OFF_T pos, size_t n);
void set_filelen_write_cache(files_struct *fsp, SMB_OFF_T file_size);
ssize_t flush_write_cache(files_struct *fsp, enum flush_reason_enum reason);
void sync_file(connection_struct *conn, files_struct *fsp);

/*The following definitions come from  smbd/filename.c  */

BOOL unix_convert(char *name,connection_struct *conn,char *saved_last_component,
                  BOOL *bad_path, SMB_STRUCT_STAT *pst);
BOOL check_name(char *name,connection_struct *conn);

/*The following definitions come from  smbd/files.c  */

files_struct *file_new(connection_struct *conn);
void file_close_conn(connection_struct *conn);
void file_init(void);
void file_close_user(int vuid);
files_struct *file_find_dit(SMB_DEV_T dev, SMB_INO_T inode, struct timeval *tval);
files_struct *file_find_fsp(files_struct *orig_fsp);
files_struct *file_find_di_first(SMB_DEV_T dev, SMB_INO_T inode);
files_struct *file_find_di_next(files_struct *start_fsp);
files_struct *file_find_print(void);
void file_sync_all(connection_struct *conn);
void file_free(files_struct *fsp);
files_struct *file_fsp(char *buf, int where);
void file_chain_reset(void);
void file_chain_save(void);
void file_chain_restore(void);

/*The following definitions come from  smbd/ipc.c  */

void send_trans_reply(char *outbuf,
		      const prs_struct *rdata,
		      const prs_struct *rparam,
		      uint16 *setup, int lsetup, int max_data_ret,
		      BOOL pipe_data_outstanding);
int reply_trans(connection_struct *conn, char *inbuf,char *outbuf, int size, int bufsize);

/*The following definitions come from  smbd/lanman.c  */

int api_reply(connection_struct * conn, uint16 vuid, char *outbuf, char *data,
	      char *params,
	      int tdscnt, int tpscnt, int mdrcnt, int mprcnt);

/*The following definitions come from  smbd/mangle.c  */

BOOL is_mangled( char *s );
BOOL is_8_3( char *fname, BOOL check_case );
void reset_mangled_cache( void );
BOOL check_mangled_cache( char *s );
void mangle_name_83( char *s);
BOOL name_map_mangle(char *OutName, BOOL need83, BOOL cache83, int snum);

/*The following definitions come from  smbd/message.c  */

int reply_sends(connection_struct *conn,
		char *inbuf,char *outbuf, int dum_size, int dum_buffsize);
int reply_sendstrt(connection_struct *conn,
		   char *inbuf,char *outbuf, int dum_size, int dum_buffsize);
int reply_sendtxt(connection_struct *conn,
		  char *inbuf,char *outbuf, int dum_size, int dum_buffsize);
int reply_sendend(connection_struct *conn,
		  char *inbuf,char *outbuf, int dum_size, int dum_buffsize);

/*The following definitions come from  smbd/negprot.c  */

int reply_negprot(connection_struct *conn,
		  char *inbuf,char *outbuf, int dum_size,
		  int dum_buffsize);

/*The following definitions come from  smbd/noquotas.c  */

BOOL disk_quotas(char *path,SMB_BIG_UINT *bsize,SMB_BIG_UINT *dfree,SMB_BIG_UINT *dsize);

/*The following definitions come from  smbd/notify.c  */

void remove_pending_change_notify_requests_by_fid(files_struct *fsp);
void remove_pending_change_notify_requests_by_mid(int mid);
void remove_pending_change_notify_requests_by_filename(files_struct *fsp);
BOOL process_pending_change_notify_queue(time_t t);
BOOL change_notifies_pending(void);
int call_nt_transact_notify_change(connection_struct *conn,
                                          char *inbuf, char *outbuf, int length,
                                          int bufsize,
                                          char **ppsetup,
                                          char **ppparams, char **ppdata);

/*The following definitions come from  smbd/nttrans.c  */

void fail_next_srvsvc_open(void);
BOOL should_fail_next_srvsvc_open(const char *pipename);
int reply_ntcreate_and_X(connection_struct *conn,
			 char *inbuf,char *outbuf,int length,int bufsize);
int reply_ntcancel(connection_struct *conn,
		   char *inbuf,char *outbuf,int length,int bufsize);
int reply_nttranss(connection_struct *conn,
		   char *inbuf,char *outbuf,int length,int bufsize);
int reply_nttrans(connection_struct *conn,
		  char *inbuf,char *outbuf,int length,int bufsize);

/*The following definitions come from  smbd/open.c  */

int fd_close(struct connection_struct *conn, files_struct *fsp);
files_struct *open_file_shared(connection_struct *conn,char *fname,int share_mode,int ofun,
		      mode_t mode,int oplock_request, int *Access,int *action);
files_struct *open_file_stat(connection_struct *conn,
		   char *fname, int smb_ofun, SMB_STRUCT_STAT *pst, int *action);
files_struct *open_directory(connection_struct *conn,
		   char *fname, int smb_ofun, mode_t unixmode, int *action);
BOOL check_file_sharing(connection_struct *conn,char *fname, BOOL rename_op);

/*The following definitions come from  smbd/oplock.c  */

int32 get_number_of_exclusive_open_oplocks(void);
BOOL receive_local_message(fd_set *fds, char *buffer, int buffer_len, int timeout);
BOOL set_file_oplock(files_struct *fsp, int oplock_type);
void release_file_oplock(files_struct *fsp);
BOOL remove_oplock(files_struct *fsp, BOOL break_to_none);
int setup_oplock_select_set( fd_set *fds);
BOOL process_local_message(char *buffer, int buf_size);
BOOL oplock_break_level2(files_struct *fsp, BOOL local_request, int token);
BOOL request_oplock_break(share_mode_entry *share_entry,
                          SMB_DEV_T dev, SMB_INO_T inode);
BOOL attempt_close_oplocked_file(files_struct *fsp);
void release_level_2_oplocks_on_change(files_struct *fsp);
BOOL init_oplocks(void);

/*The following definitions come from  smbd/oplock_irix.c  */

struct kernel_oplocks *irix_init_kernel_oplocks(void);

/*The following definitions come from  smbd/oplock_linux.c  */

struct kernel_oplocks *linux_init_kernel_oplocks(void);

/*The following definitions come from  smbd/password.c  */

void add_session_user(char *user);
uint32 password_ok(const char *orig_user, const char *domain,
		 const char *smb_apasswd, int smb_apasslen,
		 const char *smb_ntpasswd, int smb_ntpasslen,
		 struct passwd *pwd, NET_USER_INFO_3 * info3);
BOOL authorise_login(int snum, char *user, char *domain,
		     char *password, int pwlen,
		     BOOL *guest, BOOL *force, uint16 vuid);

/*The following definitions come from  smbd/pipes.c  */

int reply_open_pipe_and_X(connection_struct * conn,
			  char *inbuf, char *outbuf, int length, int bufsize);
int reply_pipe_write(char *inbuf, char *outbuf, int length, int bufsize);
int reply_pipe_write_and_X(char *inbuf, char *outbuf, int length, int bufsize);
int reply_pipe_read_and_X(char *inbuf, char *outbuf, int length, int bufsize);
int reply_pipe_close(connection_struct * conn, char *inbuf, char *outbuf);

/*The following definitions come from  smbd/process.c  */

BOOL push_oplock_pending_smb_message(char *buf, int msg_len);
BOOL receive_next_smb(char *inbuf, int bufsize, int timeout);
void respond_to_all_remaining_local_messages(void);
void process_smb(char *inbuf, char *outbuf);
char *smb_fn_name(int type);
void construct_reply_common(char *inbuf,char *outbuf);
int chain_reply(char *inbuf,char *outbuf,int size,int bufsize);
void check_reload(int t);
void smbd_process(void);

/*The following definitions come from  smbd/reply.c  */

int reply_special(char *inbuf, char *outbuf);
int reply_tcon(connection_struct * conn,
	       char *inbuf, char *outbuf, int dum_size, int dum_buffsize);
int reply_tcon_and_X(connection_struct * conn, char *inbuf, char *outbuf,
		     int length, int bufsize);
int reply_unknown(char *inbuf, char *outbuf);
int reply_ioctl(connection_struct * conn,
		char *inbuf, char *outbuf, int dum_size, int dum_buffsize);
int reply_sesssetup_and_X(connection_struct * conn, char *inbuf, char *outbuf,
			  int length, int bufsize);
int reply_chkpth(connection_struct * conn, char *inbuf, char *outbuf,
		 int dum_size, int dum_buffsize);
int reply_getatr(connection_struct * conn, char *inbuf, char *outbuf,
		 int dum_size, int dum_buffsize);
int reply_setatr(connection_struct * conn, char *inbuf, char *outbuf,
		 int dum_size, int dum_buffsize);
int reply_dskattr(connection_struct * conn, char *inbuf, char *outbuf,
		  int dum_size, int dum_buffsize);
int reply_search(connection_struct * conn, char *inbuf, char *outbuf,
		 int dum_size, int dum_buffsize);
int reply_fclose(connection_struct * conn, char *inbuf, char *outbuf,
		 int dum_size, int dum_buffsize);
int reply_open(connection_struct * conn, char *inbuf, char *outbuf,
	       int dum_size, int dum_buffsize);
int reply_open_and_X(connection_struct * conn, char *inbuf, char *outbuf,
		     int length, int bufsize);
int reply_ulogoffX(connection_struct * conn, char *inbuf, char *outbuf,
		   int length, int bufsize);
int reply_mknew(connection_struct * conn, char *inbuf, char *outbuf,
		int dum_size, int dum_buffsize);
int reply_ctemp(connection_struct * conn, char *inbuf, char *outbuf,
		int dum_size, int dum_buffsize);
int reply_unlink(connection_struct * conn, char *inbuf, char *outbuf,
		 int dum_size, int dum_buffsize);
int reply_readbraw(connection_struct * conn, char *inbuf, char *outbuf,
		   int dum_size, int dum_buffsize);
int reply_lockread(connection_struct * conn, char *inbuf, char *outbuf,
		   int length, int dum_buffsiz);
int reply_read(connection_struct * conn, char *inbuf, char *outbuf, int size,
	       int dum_buffsize);
int reply_read_and_X(connection_struct * conn, char *inbuf, char *outbuf,
		     int length, int bufsize);
int reply_writebraw(connection_struct * conn, char *inbuf, char *outbuf,
		    int size, int dum_buffsize);
int reply_writeunlock(connection_struct * conn, char *inbuf, char *outbuf,
		      int size, int dum_buffsize);
int reply_write(connection_struct * conn, char *inbuf, char *outbuf, int size,
		int dum_buffsize);
int reply_write_and_X(connection_struct * conn, char *inbuf, char *outbuf,
		      int length, int bufsize);
int reply_lseek(connection_struct * conn, char *inbuf, char *outbuf, int size,
		int dum_buffsize);
int reply_flush(connection_struct * conn, char *inbuf, char *outbuf, int size,
		int dum_buffsize);
int reply_exit(connection_struct * conn,
	       char *inbuf, char *outbuf, int dum_size, int dum_buffsize);
int reply_close(connection_struct * conn, char *inbuf, char *outbuf, int size,
		int dum_buffsize);
int reply_writeclose(connection_struct * conn,
		     char *inbuf, char *outbuf, int size, int dum_buffsize);
int reply_lock(connection_struct * conn,
	       char *inbuf, char *outbuf, int length, int dum_buffsize);
int reply_unlock(connection_struct * conn, char *inbuf, char *outbuf,
		 int size, int dum_buffsize);
int reply_tdis(connection_struct * conn,
	       char *inbuf, char *outbuf, int dum_size, int dum_buffsize);
int reply_echo(connection_struct * conn,
	       char *inbuf, char *outbuf, int dum_size, int dum_buffsize);
int reply_printopen(connection_struct * conn,
		    char *inbuf, char *outbuf, int dum_size, int dum_buffsize);
int reply_printclose(connection_struct * conn,
		     char *inbuf, char *outbuf, int dum_size,
		     int dum_buffsize);
int reply_printqueue(connection_struct * conn,
		     char *inbuf, char *outbuf, int dum_size,
		     int dum_buffsize);
int reply_printwrite(connection_struct * conn, char *inbuf, char *outbuf,
		     int dum_size, int dum_buffsize);
int reply_mkdir(connection_struct * conn, char *inbuf, char *outbuf,
		int dum_size, int dum_buffsize);
BOOL rmdir_internals(connection_struct * conn, char *directory);
int reply_rmdir(connection_struct * conn, char *inbuf, char *outbuf,
		int dum_size, int dum_buffsize);
int rename_internals(connection_struct * conn,
		     char *inbuf, char *outbuf, char *name,
		     char *newname, BOOL replace_if_exists);
int reply_mv(connection_struct * conn, char *inbuf, char *outbuf,
	     int dum_size, int dum_buffsize);
int reply_copy(connection_struct * conn, char *inbuf, char *outbuf,
	       int dum_size, int dum_buffsize);
int reply_setdir(connection_struct * conn, char *inbuf, char *outbuf,
		 int dum_size, int dum_buffsize);
uint16 get_lock_pid( char *data, int data_offset, BOOL large_file_format);
SMB_BIG_UINT get_lock_count(char *data, int data_offset,
			    BOOL large_file_format);
SMB_BIG_UINT get_lock_offset(char *data, int data_offset,
			     BOOL large_file_format, BOOL *err);
int reply_lockingX(connection_struct * conn, char *inbuf, char *outbuf,
		   int length, int bufsize);
int reply_readbmpx(connection_struct * conn, char *inbuf, char *outbuf,
		   int length, int bufsize);
int reply_writebmpx(connection_struct * conn, char *inbuf, char *outbuf,
		    int size, int dum_buffsize);
int reply_writebs(connection_struct * conn, char *inbuf, char *outbuf,
		  int dum_size, int dum_buffsize);
int reply_setattrE(connection_struct * conn, char *inbuf, char *outbuf,
		   int size, int dum_buffsize);
int reply_getattrE(connection_struct * conn, char *inbuf, char *outbuf,
		   int size, int dum_buffsize);

/*The following definitions come from  smbd/server.c  */

int smbd_server_fd(void);
BOOL reload_services(BOOL test);
void exit_server(char *reason);

/*The following definitions come from  smbd/service.c  */

BOOL become_service(connection_struct *conn,BOOL do_chdir);
int add_home_service(char *service, char *homedir);
connection_struct *make_connection(char *service,char *user,
				char *domain,
				char *password, int pwlen,
				char *dev,uint16 vuid, int *ecode);
void close_cnum(connection_struct *conn, uint16 vuid);

/*The following definitions come from  smbd/srvstr.c  */

int srvstr_push(void *base_ptr, void *dest, const char *src, int dest_len, int flags);
int srvstr_pull(void *base_ptr, char *dest, const void *src, int dest_len, int src_len,
		int flags);
int srvstr_pull_buf(void *inbuf, char *dest, const void *src, int dest_len, int flags);

/*The following definitions come from  smbd/statcache.c  */

void stat_cache_add( char *full_orig_name, char *orig_translated_path);
BOOL stat_cache_lookup(connection_struct *conn, char *name, char *dirpath,
		       char **start, SMB_STRUCT_STAT *pst);
BOOL reset_stat_cache( void );

/*The following definitions come from  smbd/trans2.c  */

int reply_findclose(connection_struct *conn,
		    char *inbuf,char *outbuf,int length,int bufsize);
int reply_findnclose(connection_struct *conn,
		     char *inbuf,char *outbuf,int length,int bufsize);
int reply_transs2(connection_struct *conn,
		  char *inbuf,char *outbuf,int length,int bufsize);
int reply_trans2(connection_struct *conn,
		 char *inbuf,char *outbuf,int length,int bufsize);

/*The following definitions come from  smbd/uid.c  */

BOOL become_user(connection_struct *conn, uint16 vuid);
BOOL unbecome_user(void );

/*The following definitions come from  smbd/unix_acls.c  */

size_t get_nt_acl(files_struct *fsp, SEC_DESC **ppdesc);

/*The following definitions come from  smbd/utmp.c  */

void utmp_yield(pid_t pid, const connection_struct *conn);
void utmp_claim(const struct connections_data *crec, const connection_struct *conn);

/*The following definitions come from  smbd/vfs-wrap.c  */


/*The following definitions come from  smbd/vfs.c  */

int vfs_init_default(connection_struct *conn);
BOOL vfs_init_custom(connection_struct *conn);
BOOL vfs_directory_exist(connection_struct *conn, char *dname,
                         SMB_STRUCT_STAT *st);
int vfs_unlink(connection_struct *conn, char *fname);
BOOL vfs_file_exist(connection_struct *conn,char *fname,SMB_STRUCT_STAT *sbuf);
ssize_t vfs_write_data(files_struct *fsp,char *buffer,size_t N);
SMB_OFF_T vfs_transfer_file(int in_fd, files_struct *in_fsp,
			    int out_fd, files_struct *out_fsp,
			    SMB_OFF_T n, char *header, int headlen, int align);
char *vfs_readdirname(connection_struct *conn, void *p);
int dos_ChDir(char *path);
char *dos_GetWd(char *path);
int vfs_ChDir(connection_struct *conn, char *path);
char *vfs_GetWd(connection_struct *conn, char *path);
BOOL reduce_name(connection_struct *conn, char *s, char *dir, BOOL widelinks);

/*The following definitions come from  smbwrapper/realcalls.c  */

int real_utime(const char *name, struct utimbuf *buf);
int real_utimes(const char *name, struct timeval tv[2]);

/*The following definitions come from  smbwrapper/shared.c  */

void smbw_setup_shared(void);
char *smbw_getshared(const char *name);
void smbw_setshared(const char *name, const char *val);
int smbw_setenv(const char *name, const char *value);
int smbw_shared_fd(int fd);

/*The following definitions come from  smbwrapper/smbw.c  */

void smbw_init(void);
int smbw_fd(int fd);
int smbw_local_fd(int fd);
ino_t smbw_inode(const char *name);
void clean_fname(char *name);
char *smbw_parse_path(const char *fname, char *server, char *share, char *path);
int smbw_path(const char *path);
int smbw_errno(struct cli_state *c);
struct smbw_server *smbw_server(char *server, char *share);
struct smbw_file *smbw_file(int fd);
int smbw_open(const char *fname, int flags, mode_t mode);
ssize_t smbw_pread(int fd, void *buf, size_t count, off_t ofs);
ssize_t smbw_read(int fd, void *buf, size_t count);
ssize_t smbw_write(int fd, void *buf, size_t count);
ssize_t smbw_pwrite(int fd, void *buf, size_t count, off_t ofs);
int smbw_close(int fd);
int smbw_fcntl(int fd, int cmd, long arg);
int smbw_access(const char *name, int mode);
int smbw_readlink(const char *path, char *buf, size_t bufsize);
int smbw_unlink(const char *fname);
int smbw_rename(const char *oldname, const char *newname);
int smbw_utime(const char *fname, void *buf);
int smbw_utimes(const char *fname, void *buf);
int smbw_chown(const char *fname, uid_t owner, gid_t group);
int smbw_chmod(const char *fname, mode_t newmode);
off_t smbw_lseek(int fd, off_t offset, int whence);
int smbw_dup(int fd);
int smbw_dup2(int fd, int fd2);
int smbw_fork(void);

/*The following definitions come from  smbwrapper/smbw_dir.c  */

struct smbw_dir *smbw_dir(int fd);
int smbw_dirp(DIR *dirp);
int smbw_dir_open(const char *fname);
int smbw_dir_fstat(int fd, struct stat *st);
int smbw_dir_close(int fd);
int smbw_getdents(unsigned int fd, struct dirent *dirp, int count);
int smbw_chdir(const char *name);
off_t smbw_dir_lseek(int fd, off_t offset, int whence);
int smbw_mkdir(const char *fname, mode_t mode);
int smbw_rmdir(const char *fname);
char *smbw_getcwd(char *buf, size_t size);
int smbw_fchdir(unsigned int fd);
DIR *smbw_opendir(const char *fname);
struct dirent *smbw_readdir(DIR *dirp);
int smbw_closedir(DIR *dirp);
void smbw_seekdir(DIR *dirp, off_t offset);
off_t smbw_telldir(DIR *dirp);

/*The following definitions come from  smbwrapper/smbw_stat.c  */

void smbw_setup_stat(struct stat *st, char *fname, size_t size, int mode);
BOOL smbw_getatr(struct smbw_server *srv, char *path,
		 uint16 *mode, size_t *size,
		 time_t *c_time, time_t *a_time, time_t *m_time,
		 SMB_INO_T *ino);
int smbw_stat_printjob(struct smbw_server *srv,char *path,
		       size_t *size, time_t *m_time);
int smbw_fstat(int fd, struct stat *st);
int smbw_stat(const char *fname, struct stat *st);

/*The following definitions come from  smbwrapper/wrapped.c  */


/*The following definitions come from  spoolssd/spoolssd.c  */

msrpc_service_fns *get_service_fns(void);

/*The following definitions come from  spoolssd/srv_spoolss_nt.c  */

void init_printer_hnd(void);
uint32 _spoolss_open_printer_ex( PRS_HANDLE *con_hnd, const UNISTR2 *printername,
				 const PRINTER_DEFAULT *printer_default,
				 uint32  user_switch, SPOOL_USER_CTR user_ctr,
				 POLICY_HND *handle);
uint32 _spoolss_closeprinter(POLICY_HND *handle);
uint32 _spoolss_deleteprinter(POLICY_HND *handle);
uint32 _spoolss_getprinterdata(const POLICY_HND *handle, UNISTR2 *valuename,
				uint32 in_size,
				uint32 *type,
				uint32 *out_size,
				uint8 **data,
				uint32 *needed);
uint32 _spoolss_rffpcnex(const POLICY_HND *handle, uint32 flags, uint32 options,
			 const UNISTR2 *localmachine, uint32 printerlocal,
			 SPOOL_NOTIFY_OPTION *option);
uint32 _spoolss_rfnpcnex( const POLICY_HND *handle, uint32 change,
			  SPOOL_NOTIFY_OPTION *option, SPOOL_NOTIFY_INFO *info);
uint32 _spoolss_enumprinters( PRS_HANDLE *con_hnd, uint32 flags, const UNISTR2 *servername, uint32 level,
			      NEW_BUFFER *buffer, uint32 offered,
			      uint32 *needed, uint32 *returned);
uint32 _spoolss_getprinter(POLICY_HND *handle, uint32 level,
			   NEW_BUFFER *buffer, uint32 offered, uint32 *needed);
uint32 _spoolss_getprinterdriver2(const POLICY_HND *handle, const UNISTR2 *uni_arch, uint32 level,
				uint32 clientmajorversion, uint32 clientminorversion,
				NEW_BUFFER *buffer, uint32 offered,
				uint32 *needed, uint32 *servermajorversion, uint32 *serverminorversion);
uint32 _spoolss_startpageprinter(const POLICY_HND *handle);
uint32 _spoolss_endpageprinter(const POLICY_HND *handle);
uint32 _spoolss_startdocprinter( const POLICY_HND *handle, uint32 level,
				DOC_INFO *docinfo, uint32 *jobid);
uint32 _spoolss_enddocprinter(const POLICY_HND *handle);
uint32 _spoolss_writeprinter( const POLICY_HND *handle,
				uint32 buffer_size,
				const uint8 *buffer,
				uint32 *buffer_written);
uint32 _spoolss_setprinter(const POLICY_HND *handle, uint32 level,
			   const SPOOL_PRINTER_INFO_LEVEL *info,
			   const DEVMODE_CTR devmode_ctr,
			   SEC_DESC_BUF *secdesc_ctr,
			   uint32 command);
uint32 _spoolss_fcpn(const POLICY_HND *handle);
uint32 _spoolss_addjob(const POLICY_HND *handle, uint32 level,
			NEW_BUFFER *buffer, uint32 offered);
uint32 _spoolss_enumjobs( POLICY_HND *handle, uint32 firstjob, uint32 numofjobs, uint32 level,
			  NEW_BUFFER *buffer, uint32 offered,
			  uint32 *needed, uint32 *returned);
uint32 _spoolss_schedulejob( const POLICY_HND *handle, uint32 jobid);
uint32 _spoolss_setjob( const POLICY_HND *handle,
				uint32 jobid,
				uint32 level,
				JOB_INFO *ctr,
				uint32 command);
uint32 _spoolss_enumprinterdrivers( PRS_HANDLE *con_hnd, UNISTR2 *name, UNISTR2 *environment, uint32 level,
				    NEW_BUFFER *buffer, uint32 offered,
				    uint32 *needed, uint32 *returned);
uint32 _new_spoolss_enumforms( const POLICY_HND *handle, uint32 level,
			       NEW_BUFFER *buffer, uint32 offered,
			       uint32 *needed, uint32 *numofforms);
uint32 _spoolss_enumports( PRS_HANDLE *con_hnd, UNISTR2 *name, uint32 level,
			   NEW_BUFFER *buffer, uint32 offered,
			   uint32 *needed, uint32 *returned);
uint32 _spoolss_addprinterex( PRS_HANDLE *con_hnd, const UNISTR2 *uni_srv_name, uint32 level,
				const SPOOL_PRINTER_INFO_LEVEL *info,
				uint32 unk0, uint32 unk1, uint32 unk2, uint32 unk3,
				uint32 user_switch, const SPOOL_USER_CTR *user,
				POLICY_HND *handle);
uint32 _spoolss_addprinterdriver( PRS_HANDLE *con_hnd, const UNISTR2 *server_name,
				uint32 level, const SPOOL_PRINTER_DRIVER_INFO_LEVEL *info);
uint32 _spoolss_getprinterdriverdirectory(PRS_HANDLE *con_hnd, UNISTR2 *name, UNISTR2 *uni_environment, uint32 level,
					NEW_BUFFER *buffer, uint32 offered,
					uint32 *needed);
uint32 _spoolss_enumprinterdata(const POLICY_HND *handle, uint32 idx,
				uint32 in_value_len, uint32 in_data_len,
				uint32 *out_max_value_len, uint16 **out_value, uint32 *out_value_len,
				uint32 *out_type,
				uint32 *out_max_data_len, uint8  **data_out, uint32 *out_data_len);
uint32 _spoolss_setprinterdata( const POLICY_HND *handle,
				const UNISTR2 *value,
				uint32 type,
				uint32 max_len,
				const uint8 *data,
				uint32 real_len,
				uint32 numeric_data);
uint32 _spoolss_addform( const POLICY_HND *handle,
				uint32 level,
				const FORM *form);
uint32 _spoolss_setform( const POLICY_HND *handle,
				const UNISTR2 *uni_name,
				uint32 level,
				const FORM *form);
uint32 _spoolss_enumprintprocessors(PRS_HANDLE *con_hnd, UNISTR2 *name, UNISTR2 *environment, uint32 level,
				    NEW_BUFFER *buffer, uint32 offered,
				    uint32 *needed, uint32 *returned);
uint32 _spoolss_enumprintprocdatatypes(PRS_HANDLE *hnd, UNISTR2 *name, UNISTR2 *processor, uint32 level,
					NEW_BUFFER *buffer, uint32 offered,
					uint32 *needed, uint32 *returned);
uint32 _spoolss_enumprintmonitors(PRS_HANDLE *hnd, UNISTR2 *name,uint32 level,
				    NEW_BUFFER *buffer, uint32 offered,
				    uint32 *needed, uint32 *returned);
uint32 _spoolss_getjob( POLICY_HND *handle, uint32 jobid, uint32 level,
			NEW_BUFFER *buffer, uint32 offered,
			uint32 *needed);

/*The following definitions come from  srvsvcd/srv_srvsvc_nt.c  */

uint32 _srv_net_remote_tod(PRS_HANDLE *con_hnd, UNISTR2 *srv_name, TIME_OF_DAY_INFO * tod);
uint32 _srv_net_srv_get_info(PRS_HANDLE *con_hnd, UNISTR2 *srv_name, uint32 switch_value,
			     SRV_INFO_CTR * ctr);
uint32 _srv_net_share_enum(PRS_HANDLE *con_hnd, const UNISTR2 *srv_name,
			   uint32 switch_value, SRV_SHARE_INFO_CTR * ctr,
			   uint32 preferred_len, ENUM_HND * enum_hnd,
			   uint32 *total_entries, uint32 share_level);
uint32 _srv_net_share_add(PRS_HANDLE *con_hnd, const UNISTR2 *srv_name,
			  uint32 info_level,
			  const SHARE_INFO_CTR * ctr, uint32 *parm_error);
uint32 _srv_net_share_get_info(PRS_HANDLE *con_hnd, const UNISTR2 *srv_name,
			       const UNISTR2 *share_name, uint32 info_level,
			       SHARE_INFO_CTR * ctr);
uint32 _srv_net_sess_enum(PRS_HANDLE *con_hnd, const UNISTR2 *srv_name,
			  uint32 switch_value, SRV_SESS_INFO_CTR * ctr,
			  uint32 preferred_len, ENUM_HND * enum_hnd,
			  uint32 *total_entries, uint32 sess_level);
uint32 _srv_net_conn_enum(PRS_HANDLE *con_hnd, const UNISTR2 *srv_name,
			  uint32 switch_value, SRV_CONN_INFO_CTR * ctr,
			  uint32 preferred_len, ENUM_HND * enum_hnd,
			  uint32 *total_entries, uint32 conn_level);
uint32 _srv_net_file_enum(PRS_HANDLE *con_hnd, const UNISTR2 *srv_name,
			  uint32 switch_value, SRV_FILE_INFO_CTR * ctr,
			  uint32 preferred_len, ENUM_HND * enum_hnd,
			  uint32 *total_entries, uint32 file_level);

/*The following definitions come from  srvsvcd/srvsvcd.c  */

msrpc_service_fns *get_service_fns(void);

/*The following definitions come from  svcctld/srv_svcctl_nt.c  */

uint32 _svc_close(POLICY_HND *pol);
uint32 _svc_open_service(const POLICY_HND *scman_pol,
				 const UNISTR2* uni_svc_name,
				 uint32 des_access,
				 POLICY_HND *pol);
uint32 _svc_stop_service(const POLICY_HND *pol,
				 uint32 unknown,
				 SVC_STATUS *svc_status);
uint32 _svc_start_service(const POLICY_HND *pol,
				  uint32 argc,
				  uint32 argc2,
				  const UNISTR2 *argv);
uint32 _svc_open_sc_man(PRS_HANDLE *hnd,
			const UNISTR2 *uni_srv_name,
			const UNISTR2 *uni_db_name,
			uint32 des_access,
			POLICY_HND *pol);
uint32 _svc_enum_svcs_status(const POLICY_HND *pol,
				     uint32 service_type,
				     uint32 service_state,
				     uint32 *buf_size,
				     ENUM_HND *resume_hnd,
				     ENUM_SRVC_STATUS *svcs,
				     uint32 *more_buf_size,
				     uint32 *num_svcs);
uint32 _svc_query_disp_name(const POLICY_HND *scman_pol,
				    const UNISTR2 *uni_svc_name,
				    uint32 buf_size,
				    UNISTR2 *uni_disp_name,
				    uint32 *pbuf_size);
uint32 _svc_unknown_3(const POLICY_HND *scman_hnd, POLICY_HND *hnd);
uint32 _svc_query_svc_config(const POLICY_HND *hnd, QUERY_SERVICE_CONFIG *cfg,
			     uint32 *buf_size);
uint32 _svc_query_svc_status(const POLICY_HND *hnd, SVC_STATUS *status);

/*The following definitions come from  svcctld/svcctld.c  */

msrpc_service_fns *get_service_fns(void);

/*The following definitions come from  utils/rpctorture.c  */


/*The following definitions come from  utils/smbpasswd.c  */

int main(int argc, char **argv);

/*The following definitions come from  uuid/uuid.c  */


/*The following definitions come from  winregd/srv_reg_nt.c  */

uint32 _reg_close(POLICY_HND * pol);
uint32 _reg_open_hklm(PRS_HANDLE *con_hnd, POLICY_HND * pol, uint32 access_mask);
uint32 _reg_open_entry(const POLICY_HND * pol, const UNISTR2 * uni_name,
		       uint32 unknown_0, uint32 access_mask,
		       POLICY_HND * entry_pol);
uint32 _reg_info(POLICY_HND * pol, BUFFER2 * buf, uint32 * type);
BOOL api_reg_rpc(rpcsrv_struct * p);

/*The following definitions come from  winregd/winregd.c  */

msrpc_service_fns *get_service_fns(void);

/*The following definitions come from  wkssvcd/srv_wkssvc_nt.c  */

uint32 _wks_query_info( PRS_HANDLE *con_hnd, const UNISTR2 *srv_name, uint16 switch_value,
			WKS_INFO_100 *wks100);

/*The following definitions come from  wkssvcd/wkssvcd.c  */

msrpc_service_fns *get_service_fns(void);
#endif /* _PROTO_H_ */
